# binance_spot
OpenAPI Specifications for the Binance Public Spot API  API documents:   - [https://github.com/binance/binance-spot-api-docs](https://github.com/binance/binance-spot-api-docs)   - [https://binance-docs.github.io/apidocs/spot/en](https://binance-docs.github.io/apidocs/spot/en)

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/Halimao/binance-spot-sdk.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/Halimao/binance-spot-sdk.git`)

Then import the package:
```python
import binance_spot 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import binance_spot
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import binance_spot
from binance_spot.rest import ApiException
from pprint import pprint

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Query all source asset and target asset (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_all_asset_get(timestamp, signature, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_all_asset_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
plan_id = 789 # int |  (optional)
start_time = 789 # int | UTC timestamp in ms (optional)
end_time = 789 # int | UTC timestamp in ms (optional)
target_asset = 1.2 # float |  (optional)
plan_type = 'plan_type_example' # str |  (optional)
size = 56 # int | Default:10 Max:100 (optional)
current = 56 # int | Current querying page. Start from 1. Default:1 (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Query subscription transaction history
    api_response = api_instance.sapi_v1_lending_auto_invest_history_list_get(timestamp, signature, plan_id=plan_id, start_time=start_time, end_time=end_time, target_asset=target_asset, plan_type=plan_type, size=size, current=current, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_history_list_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
index_id = 789 # int | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Query Index Details(USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_index_info_get(index_id, timestamp, signature, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_index_info_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
index_id = 789 # int | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Query Index Linked Plan Position Details(USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_index_user_summary_get(index_id, timestamp, signature, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_index_user_summary_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
source_type = 'source_type_example' # str | 
subscription_amount = 3.4 # float | 
source_asset = 'source_asset_example' # str | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
request_id = 'request_id_example' # str |  (optional)
flexible_allowed_to_use = true # bool |  (optional)
plan_id = 789 # int |  (optional)
index_id = 789 # int |  (optional)
details = [binance_spot.Details2()] # list[Details2] |  (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # One Time Transaction(TRADE)
    api_response = api_instance.sapi_v1_lending_auto_invest_one_off_post(source_type, subscription_amount, source_asset, timestamp, signature, request_id=request_id, flexible_allowed_to_use=flexible_allowed_to_use, plan_id=plan_id, index_id=index_id, details=details, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_one_off_post: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
transaction_id = 789 # int | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
request_id = 'request_id_example' # str |  (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Query One-Time Transaction Status (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_one_off_status_get(transaction_id, timestamp, signature, request_id=request_id, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_one_off_status_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
source_type = 'source_type_example' # str | 
plan_type = 'plan_type_example' # str | 
subscription_amount = 3.4 # float | 
subscription_cycle = 'subscription_cycle_example' # str | 
subscription_start_time = 56 # int | 
source_asset = 'source_asset_example' # str | 
details = [binance_spot.Details()] # list[Details] | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
request_id = 'request_id_example' # str |  (optional)
index_id = 789 # int |  (optional)
subscription_start_day = 56 # int |  (optional)
subscription_start_weekday = 'subscription_start_weekday_example' # str |  (optional)
flexible_allowed_to_use = true # bool |  (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Investment plan creation (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_plan_add_post(source_type, plan_type, subscription_amount, subscription_cycle, subscription_start_time, source_asset, details, timestamp, signature, request_id=request_id, index_id=index_id, subscription_start_day=subscription_start_day, subscription_start_weekday=subscription_start_weekday, flexible_allowed_to_use=flexible_allowed_to_use, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_plan_add_post: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
plan_id = 56 # int | 
subscription_amount = 3.4 # float | 
subscription_cycle = 'subscription_cycle_example' # str | 
subscription_start_time = 56 # int | 
source_asset = 'source_asset_example' # str | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
subscription_start_day = 56 # int |  (optional)
subscription_start_weekday = 'subscription_start_weekday_example' # str |  (optional)
flexible_allowed_to_use = true # bool |  (optional)
details = [binance_spot.Details1()] # list[Details1] |  (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Investment plan adjustment
    api_response = api_instance.sapi_v1_lending_auto_invest_plan_edit_post(plan_id, subscription_amount, subscription_cycle, subscription_start_time, source_asset, timestamp, signature, subscription_start_day=subscription_start_day, subscription_start_weekday=subscription_start_weekday, flexible_allowed_to_use=flexible_allowed_to_use, details=details, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_plan_edit_post: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
plan_id = 56 # int | 
status = 'status_example' # str | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Change Plan Status
    api_response = api_instance.sapi_v1_lending_auto_invest_plan_edit_status_post(plan_id, status, timestamp, signature, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_plan_edit_status_post: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
plan_id = 789 # int |  (optional)
request_id = 'request_id_example' # str |  (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Query holding details of the plan
    api_response = api_instance.sapi_v1_lending_auto_invest_plan_id_get(timestamp, signature, plan_id=plan_id, request_id=request_id, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_plan_id_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
plan_type = 'plan_type_example' # str | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Get list of plans
    api_response = api_instance.sapi_v1_lending_auto_invest_plan_list_get(plan_type, timestamp, signature, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_plan_list_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
start_time = 789 # int | UTC timestamp in ms (optional)
end_time = 789 # int | UTC timestamp in ms (optional)
current = 56 # int | Current querying page. Start from 1. Default:1 (optional)
size = 56 # int | Default:10 Max:100 (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Index Linked Plan Rebalance Details (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_rebalance_history_get(timestamp, signature, start_time=start_time, end_time=end_time, current=current, size=size, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_rebalance_history_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
request_id = 789 # int | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
start_time = 789 # int | UTC timestamp in ms (optional)
end_time = 789 # int | UTC timestamp in ms (optional)
current = 56 # int | Current querying page. Start from 1. Default:1 (optional)
asset = 'asset_example' # str |  (optional)
size = 56 # int | Default:10 Max:100 (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Index Linked Plan Redemption History (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_redeem_history_get(request_id, timestamp, signature, start_time=start_time, end_time=end_time, current=current, asset=asset, size=size, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_redeem_history_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
index_id = 789 # int | PORTFOLIO plan's Id
redemption_percentage = 56 # int | user redeem percentage,10/20/100.
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
request_id = 'request_id_example' # str | sourceType + unique, transactionId and requestId cannot be empty at the same time (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Index Linked Plan Redemption (TRADE)
    api_response = api_instance.sapi_v1_lending_auto_invest_redeem_post(index_id, redemption_percentage, timestamp, signature, request_id=request_id, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_redeem_post: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
usage_type = 'usage_type_example' # str | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
target_asset = 'target_asset_example' # str |  (optional)
index_id = 789 # int |  (optional)
flexible_allowed_to_use = true # bool |  (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Query source asset list (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_source_asset_list_get(usage_type, timestamp, signature, target_asset=target_asset, index_id=index_id, flexible_allowed_to_use=flexible_allowed_to_use, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_source_asset_list_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
target_asset = 'target_asset_example' # str |  (optional)
size = 56 # int | Default:10 Max:100 (optional)
current = 56 # int | Current querying page. Start from 1. Default:1 (optional)
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Get target asset list (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_target_asset_list_get(timestamp, signature, target_asset=target_asset, size=size, current=current, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_target_asset_list_get: %s\n" % e)

# Configure API key authorization: ApiKeyAuth
configuration = binance_spot.Configuration()
configuration.api_key['X-MBX-APIKEY'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['X-MBX-APIKEY'] = 'Bearer'

# create an instance of the API class
api_instance = binance_spot.AutoInvestApi(binance_spot.ApiClient(configuration))
target_asset = 'target_asset_example' # str | 
his_roi_type = 'his_roi_type_example' # str | 
timestamp = 789 # int | UTC timestamp in ms
signature = 'signature_example' # str | Signature
recv_window = 789 # int | The value cannot be greater than 60000 (optional)

try:
    # Get target asset ROI data (USER_DATA)
    api_response = api_instance.sapi_v1_lending_auto_invest_target_asset_roi_list_get(target_asset, his_roi_type, timestamp, signature, recv_window=recv_window)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling AutoInvestApi->sapi_v1_lending_auto_invest_target_asset_roi_list_get: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.binance.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_all_asset_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_all_asset_get) | **GET** /sapi/v1/lending/auto-invest/all/asset | Query all source asset and target asset (USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_history_list_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_history_list_get) | **GET** /sapi/v1/lending/auto-invest/history/list | Query subscription transaction history
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_index_info_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_index_info_get) | **GET** /sapi/v1/lending/auto-invest/index/info | Query Index Details(USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_index_user_summary_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_index_user_summary_get) | **GET** /sapi/v1/lending/auto-invest/index/user-summary | Query Index Linked Plan Position Details(USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_one_off_post**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_one_off_post) | **POST** /sapi/v1/lending/auto-invest/one-off | One Time Transaction(TRADE)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_one_off_status_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_one_off_status_get) | **GET** /sapi/v1/lending/auto-invest/one-off/status | Query One-Time Transaction Status (USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_plan_add_post**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_plan_add_post) | **POST** /sapi/v1/lending/auto-invest/plan/add | Investment plan creation (USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_plan_edit_post**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_plan_edit_post) | **POST** /sapi/v1/lending/auto-invest/plan/edit | Investment plan adjustment
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_plan_edit_status_post**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_plan_edit_status_post) | **POST** /sapi/v1/lending/auto-invest/plan/edit-status | Change Plan Status
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_plan_id_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_plan_id_get) | **GET** /sapi/v1/lending/auto-invest/plan/id | Query holding details of the plan
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_plan_list_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_plan_list_get) | **GET** /sapi/v1/lending/auto-invest/plan/list | Get list of plans
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_rebalance_history_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_rebalance_history_get) | **GET** /sapi/v1/lending/auto-invest/rebalance/history | Index Linked Plan Rebalance Details (USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_redeem_history_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_redeem_history_get) | **GET** /sapi/v1/lending/auto-invest/redeem/history | Index Linked Plan Redemption History (USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_redeem_post**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_redeem_post) | **POST** /sapi/v1/lending/auto-invest/redeem | Index Linked Plan Redemption (TRADE)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_source_asset_list_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_source_asset_list_get) | **GET** /sapi/v1/lending/auto-invest/source-asset/list | Query source asset list (USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_target_asset_list_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_target_asset_list_get) | **GET** /sapi/v1/lending/auto-invest/target-asset/list | Get target asset list (USER_DATA)
*AutoInvestApi* | [**sapi_v1_lending_auto_invest_target_asset_roi_list_get**](docs/AutoInvestApi.md#sapi_v1_lending_auto_invest_target_asset_roi_list_get) | **GET** /sapi/v1/lending/auto-invest/target-asset/roi/list | Get target asset ROI data (USER_DATA)
*BLVTApi* | [**sapi_v1_blvt_redeem_post**](docs/BLVTApi.md#sapi_v1_blvt_redeem_post) | **POST** /sapi/v1/blvt/redeem | Redeem BLVT (USER_DATA)
*BLVTApi* | [**sapi_v1_blvt_redeem_record_get**](docs/BLVTApi.md#sapi_v1_blvt_redeem_record_get) | **GET** /sapi/v1/blvt/redeem/record | Redemption Record (USER_DATA)
*BLVTApi* | [**sapi_v1_blvt_subscribe_post**](docs/BLVTApi.md#sapi_v1_blvt_subscribe_post) | **POST** /sapi/v1/blvt/subscribe | Subscribe BLVT (USER_DATA)
*BLVTApi* | [**sapi_v1_blvt_subscribe_record_get**](docs/BLVTApi.md#sapi_v1_blvt_subscribe_record_get) | **GET** /sapi/v1/blvt/subscribe/record | Query Subscription Record (USER_DATA)
*BLVTApi* | [**sapi_v1_blvt_token_info_get**](docs/BLVTApi.md#sapi_v1_blvt_token_info_get) | **GET** /sapi/v1/blvt/tokenInfo | BLVT Info (MARKET_DATA)
*BLVTApi* | [**sapi_v1_blvt_user_limit_get**](docs/BLVTApi.md#sapi_v1_blvt_user_limit_get) | **GET** /sapi/v1/blvt/userLimit | BLVT User Limit Info (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_add_liquidity_preview_get**](docs/BSwapApi.md#sapi_v1_bswap_add_liquidity_preview_get) | **GET** /sapi/v1/bswap/addLiquidityPreview | Add Liquidity Preview (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_claim_rewards_post**](docs/BSwapApi.md#sapi_v1_bswap_claim_rewards_post) | **POST** /sapi/v1/bswap/claimRewards | Claim rewards (TRADE)
*BSwapApi* | [**sapi_v1_bswap_claimed_history_get**](docs/BSwapApi.md#sapi_v1_bswap_claimed_history_get) | **GET** /sapi/v1/bswap/claimedHistory | Get Claimed History (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_liquidity_add_post**](docs/BSwapApi.md#sapi_v1_bswap_liquidity_add_post) | **POST** /sapi/v1/bswap/liquidityAdd | Add Liquidity (TRADE)
*BSwapApi* | [**sapi_v1_bswap_liquidity_get**](docs/BSwapApi.md#sapi_v1_bswap_liquidity_get) | **GET** /sapi/v1/bswap/liquidity | Liquidity information of a pool (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_liquidity_ops_get**](docs/BSwapApi.md#sapi_v1_bswap_liquidity_ops_get) | **GET** /sapi/v1/bswap/liquidityOps | Liquidity Operation Record (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_liquidity_remove_post**](docs/BSwapApi.md#sapi_v1_bswap_liquidity_remove_post) | **POST** /sapi/v1/bswap/liquidityRemove | Remove Liquidity (TRADE)
*BSwapApi* | [**sapi_v1_bswap_pool_configure_get**](docs/BSwapApi.md#sapi_v1_bswap_pool_configure_get) | **GET** /sapi/v1/bswap/poolConfigure | Pool Configure (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_pools_get**](docs/BSwapApi.md#sapi_v1_bswap_pools_get) | **GET** /sapi/v1/bswap/pools | List All Swap Pools (MARKET_DATA)
*BSwapApi* | [**sapi_v1_bswap_quote_get**](docs/BSwapApi.md#sapi_v1_bswap_quote_get) | **GET** /sapi/v1/bswap/quote | Request Quote (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_remove_liquidity_preview_get**](docs/BSwapApi.md#sapi_v1_bswap_remove_liquidity_preview_get) | **GET** /sapi/v1/bswap/removeLiquidityPreview | Remove Liquidity Preview (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_swap_get**](docs/BSwapApi.md#sapi_v1_bswap_swap_get) | **GET** /sapi/v1/bswap/swap | Swap History (USER_DATA)
*BSwapApi* | [**sapi_v1_bswap_swap_post**](docs/BSwapApi.md#sapi_v1_bswap_swap_post) | **POST** /sapi/v1/bswap/swap | Swap (TRADE)
*BSwapApi* | [**sapi_v1_bswap_unclaimed_rewards_get**](docs/BSwapApi.md#sapi_v1_bswap_unclaimed_rewards_get) | **GET** /sapi/v1/bswap/unclaimedRewards | Get Unclaimed Rewards Record (USER_DATA)
*C2CApi* | [**sapi_v1_c2c_order_match_list_user_order_history_get**](docs/C2CApi.md#sapi_v1_c2c_order_match_list_user_order_history_get) | **GET** /sapi/v1/c2c/orderMatch/listUserOrderHistory | Get C2C Trade History (USER_DATA)
*ConvertApi* | [**sapi_v1_convert_accept_quote_post**](docs/ConvertApi.md#sapi_v1_convert_accept_quote_post) | **POST** /sapi/v1/convert/acceptQuote | Accept Quote (TRADE)
*ConvertApi* | [**sapi_v1_convert_asset_info_get**](docs/ConvertApi.md#sapi_v1_convert_asset_info_get) | **GET** /sapi/v1/convert/assetInfo | Query order quantity precision per asset (USER_DATA)
*ConvertApi* | [**sapi_v1_convert_exchange_info_get**](docs/ConvertApi.md#sapi_v1_convert_exchange_info_get) | **GET** /sapi/v1/convert/exchangeInfo | List All Convert Pairs
*ConvertApi* | [**sapi_v1_convert_get_quote_post**](docs/ConvertApi.md#sapi_v1_convert_get_quote_post) | **POST** /sapi/v1/convert/getQuote | Send quote request (USER_DATA)
*ConvertApi* | [**sapi_v1_convert_order_status_get**](docs/ConvertApi.md#sapi_v1_convert_order_status_get) | **GET** /sapi/v1/convert/orderStatus | Order status (USER_DATA)
*ConvertApi* | [**sapi_v1_convert_trade_flow_get**](docs/ConvertApi.md#sapi_v1_convert_trade_flow_get) | **GET** /sapi/v1/convert/tradeFlow | Get Convert Trade History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_adjust_ltv_post**](docs/CryptoLoansApi.md#sapi_v1_loan_adjust_ltv_post) | **POST** /sapi/v1/loan/adjust/ltv | Crypto Loan Adjust LTV (TRADE)
*CryptoLoansApi* | [**sapi_v1_loan_borrow_history_get**](docs/CryptoLoansApi.md#sapi_v1_loan_borrow_history_get) | **GET** /sapi/v1/loan/borrow/history | Get Crypto Loans Borrow History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_borrow_post**](docs/CryptoLoansApi.md#sapi_v1_loan_borrow_post) | **POST** /sapi/v1/loan/borrow | Crypto Loan Borrow (TRADE)
*CryptoLoansApi* | [**sapi_v1_loan_collateral_data_get**](docs/CryptoLoansApi.md#sapi_v1_loan_collateral_data_get) | **GET** /sapi/v1/loan/collateral/data | Get Collateral Assets Data (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_customize_margin_call_post**](docs/CryptoLoansApi.md#sapi_v1_loan_customize_margin_call_post) | **POST** /sapi/v1/loan/customize/margin_call | Crypto Loan Customize Margin Call (TRADE)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_adjust_ltv_post**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_adjust_ltv_post) | **POST** /sapi/v1/loan/flexible/adjust/ltv | Adjust LTV - Flexible Loan Adjust LTV (TRADE)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_borrow_history_get**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_borrow_history_get) | **GET** /sapi/v1/loan/flexible/borrow/history | Borrow - Get Flexible Loan Borrow History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_borrow_post**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_borrow_post) | **POST** /sapi/v1/loan/flexible/borrow | Borrow - Flexible Loan Borrow (TRADE)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_collateral_data_get**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_collateral_data_get) | **GET** /sapi/v1/loan/flexible/collateral/data | Get Flexible Loan Collateral Assets Data (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_loanable_data_get**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_loanable_data_get) | **GET** /sapi/v1/loan/flexible/loanable/data | Get Flexible Loan Assets Data (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_ltv_adjustment_history_get**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_ltv_adjustment_history_get) | **GET** /sapi/v1/loan/flexible/ltv/adjustment/history | Adjust LTV - Get Flexible Loan LTV Adjustment History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_ongoing_orders_get**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_ongoing_orders_get) | **GET** /sapi/v1/loan/flexible/ongoing/orders | Borrow - Get Flexible Loan Ongoing Orders (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_repay_history_get**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_repay_history_get) | **GET** /sapi/v1/loan/flexible/repay/history | Repay - Get Flexible Loan Repayment History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_flexible_repay_post**](docs/CryptoLoansApi.md#sapi_v1_loan_flexible_repay_post) | **POST** /sapi/v1/loan/flexible/repay | Repay - Flexible Loan Repay (TRADE)
*CryptoLoansApi* | [**sapi_v1_loan_income_get**](docs/CryptoLoansApi.md#sapi_v1_loan_income_get) | **GET** /sapi/v1/loan/income | Get Crypto Loans Income History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_loanable_data_get**](docs/CryptoLoansApi.md#sapi_v1_loan_loanable_data_get) | **GET** /sapi/v1/loan/loanable/data | Get Loanable Assets Data (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_ltv_adjustment_history_get**](docs/CryptoLoansApi.md#sapi_v1_loan_ltv_adjustment_history_get) | **GET** /sapi/v1/loan/ltv/adjustment/history | Get Loan LTV Adjustment History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_ongoing_orders_get**](docs/CryptoLoansApi.md#sapi_v1_loan_ongoing_orders_get) | **GET** /sapi/v1/loan/ongoing/orders | Get Loan Ongoing Orders (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_repay_collateral_rate_get**](docs/CryptoLoansApi.md#sapi_v1_loan_repay_collateral_rate_get) | **GET** /sapi/v1/loan/repay/collateral/rate | Check Collateral Repay Rate (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_repay_history_get**](docs/CryptoLoansApi.md#sapi_v1_loan_repay_history_get) | **GET** /sapi/v1/loan/repay/history | Get Loan Repayment History (USER_DATA)
*CryptoLoansApi* | [**sapi_v1_loan_repay_post**](docs/CryptoLoansApi.md#sapi_v1_loan_repay_post) | **POST** /sapi/v1/loan/repay | Crypto Loan Repay (TRADE)
*FiatApi* | [**sapi_v1_fiat_orders_get**](docs/FiatApi.md#sapi_v1_fiat_orders_get) | **GET** /sapi/v1/fiat/orders | Fiat Deposit/Withdraw History (USER_DATA)
*FiatApi* | [**sapi_v1_fiat_payments_get**](docs/FiatApi.md#sapi_v1_fiat_payments_get) | **GET** /sapi/v1/fiat/payments | Fiat Payments History (USER_DATA)
*FuturesApi* | [**sapi_v1_futures_hist_data_link_get**](docs/FuturesApi.md#sapi_v1_futures_hist_data_link_get) | **GET** /sapi/v1/futures/histDataLink | Get Future TickLevel Orderbook Historical Data Download Link (USER_DATA)
*FuturesApi* | [**sapi_v1_futures_transfer_get**](docs/FuturesApi.md#sapi_v1_futures_transfer_get) | **GET** /sapi/v1/futures/transfer | Get Future Account Transaction History List (USER_DATA)
*FuturesApi* | [**sapi_v1_futures_transfer_post**](docs/FuturesApi.md#sapi_v1_futures_transfer_post) | **POST** /sapi/v1/futures/transfer | New Future Account Transfer (USER_DATA)
*FuturesAlgoApi* | [**sapi_v1_algo_futures_historical_orders_get**](docs/FuturesAlgoApi.md#sapi_v1_algo_futures_historical_orders_get) | **GET** /sapi/v1/algo/futures/historicalOrders | Query Historical Algo Orders (USER_DATA)
*FuturesAlgoApi* | [**sapi_v1_algo_futures_new_order_twap_post**](docs/FuturesAlgoApi.md#sapi_v1_algo_futures_new_order_twap_post) | **POST** /sapi/v1/algo/futures/newOrderTwap | Time-Weighted Average Price(Twap) New Order (TRADE)
*FuturesAlgoApi* | [**sapi_v1_algo_futures_new_order_vp_post**](docs/FuturesAlgoApi.md#sapi_v1_algo_futures_new_order_vp_post) | **POST** /sapi/v1/algo/futures/newOrderVp | Volume Participation(VP) New Order (TRADE)
*FuturesAlgoApi* | [**sapi_v1_algo_futures_open_orders_get**](docs/FuturesAlgoApi.md#sapi_v1_algo_futures_open_orders_get) | **GET** /sapi/v1/algo/futures/openOrders | Query Current Algo Open Orders (USER_DATA)
*FuturesAlgoApi* | [**sapi_v1_algo_futures_order_delete**](docs/FuturesAlgoApi.md#sapi_v1_algo_futures_order_delete) | **DELETE** /sapi/v1/algo/futures/order | Cancel Algo Order(TRADE)
*FuturesAlgoApi* | [**sapi_v1_algo_futures_sub_orders_get**](docs/FuturesAlgoApi.md#sapi_v1_algo_futures_sub_orders_get) | **GET** /sapi/v1/algo/futures/subOrders | Query Sub Orders (USER_DATA)
*GiftCardApi* | [**sapi_v1_giftcard_buy_code_post**](docs/GiftCardApi.md#sapi_v1_giftcard_buy_code_post) | **POST** /sapi/v1/giftcard/buyCode | Buy a Binance Code (TRADE)
*GiftCardApi* | [**sapi_v1_giftcard_buy_code_token_limit_get**](docs/GiftCardApi.md#sapi_v1_giftcard_buy_code_token_limit_get) | **GET** /sapi/v1/giftcard/buyCode/token-limit | Fetch Token Limit (USER_DATA)
*GiftCardApi* | [**sapi_v1_giftcard_create_code_post**](docs/GiftCardApi.md#sapi_v1_giftcard_create_code_post) | **POST** /sapi/v1/giftcard/createCode | Create a Binance Code (USER_DATA)
*GiftCardApi* | [**sapi_v1_giftcard_cryptography_rsa_public_key_get**](docs/GiftCardApi.md#sapi_v1_giftcard_cryptography_rsa_public_key_get) | **GET** /sapi/v1/giftcard/cryptography/rsa-public-key | Fetch RSA Public Key (USER_DATA)
*GiftCardApi* | [**sapi_v1_giftcard_redeem_code_post**](docs/GiftCardApi.md#sapi_v1_giftcard_redeem_code_post) | **POST** /sapi/v1/giftcard/redeemCode | Redeem a Binance Code (USER_DATA)
*GiftCardApi* | [**sapi_v1_giftcard_verify_get**](docs/GiftCardApi.md#sapi_v1_giftcard_verify_get) | **GET** /sapi/v1/giftcard/verify | Verify a Binance Code (USER_DATA)
*IsolatedMarginStreamApi* | [**sapi_v1_user_data_stream_isolated_delete**](docs/IsolatedMarginStreamApi.md#sapi_v1_user_data_stream_isolated_delete) | **DELETE** /sapi/v1/userDataStream/isolated | Close a ListenKey (USER_STREAM)
*IsolatedMarginStreamApi* | [**sapi_v1_user_data_stream_isolated_post**](docs/IsolatedMarginStreamApi.md#sapi_v1_user_data_stream_isolated_post) | **POST** /sapi/v1/userDataStream/isolated | Generate a Listen Key (USER_STREAM)
*IsolatedMarginStreamApi* | [**sapi_v1_user_data_stream_isolated_put**](docs/IsolatedMarginStreamApi.md#sapi_v1_user_data_stream_isolated_put) | **PUT** /sapi/v1/userDataStream/isolated | Ping/Keep-alive a Listen Key (USER_STREAM)
*MarginApi* | [**sapi_v1_bnb_burn_get**](docs/MarginApi.md#sapi_v1_bnb_burn_get) | **GET** /sapi/v1/bnbBurn | Get BNB Burn Status(USER_DATA)
*MarginApi* | [**sapi_v1_bnb_burn_post**](docs/MarginApi.md#sapi_v1_bnb_burn_post) | **POST** /sapi/v1/bnbBurn | Toggle BNB Burn On Spot Trade And Margin Interest (USER_DATA)
*MarginApi* | [**sapi_v1_margin_account_get**](docs/MarginApi.md#sapi_v1_margin_account_get) | **GET** /sapi/v1/margin/account | Query Cross Margin Account Details (USER_DATA)
*MarginApi* | [**sapi_v1_margin_all_assets_get**](docs/MarginApi.md#sapi_v1_margin_all_assets_get) | **GET** /sapi/v1/margin/allAssets | Get All Margin Assets (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_all_order_list_get**](docs/MarginApi.md#sapi_v1_margin_all_order_list_get) | **GET** /sapi/v1/margin/allOrderList | Query Margin Account&#x27;s all OCO (USER_DATA)
*MarginApi* | [**sapi_v1_margin_all_orders_get**](docs/MarginApi.md#sapi_v1_margin_all_orders_get) | **GET** /sapi/v1/margin/allOrders | Query Margin Account&#x27;s All Orders (USER_DATA)
*MarginApi* | [**sapi_v1_margin_all_pairs_get**](docs/MarginApi.md#sapi_v1_margin_all_pairs_get) | **GET** /sapi/v1/margin/allPairs | Get All Cross Margin Pairs (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_asset_get**](docs/MarginApi.md#sapi_v1_margin_asset_get) | **GET** /sapi/v1/margin/asset | Query Margin Asset (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_available_inventory_get**](docs/MarginApi.md#sapi_v1_margin_available_inventory_get) | **GET** /sapi/v1/margin/available-inventory | Query Margin Available Inventory (USER_DATA)
*MarginApi* | [**sapi_v1_margin_capital_flow_get**](docs/MarginApi.md#sapi_v1_margin_capital_flow_get) | **GET** /sapi/v1/margin/capital-flow | Get cross or isolated margin capital flow(USER_DATA)
*MarginApi* | [**sapi_v1_margin_cross_margin_collateral_ratio_get**](docs/MarginApi.md#sapi_v1_margin_cross_margin_collateral_ratio_get) | **GET** /sapi/v1/margin/crossMarginCollateralRatio | Cross margin collateral ratio (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_cross_margin_data_get**](docs/MarginApi.md#sapi_v1_margin_cross_margin_data_get) | **GET** /sapi/v1/margin/crossMarginData | Query Cross Margin Fee Data (USER_DATA)
*MarginApi* | [**sapi_v1_margin_delist_schedule_get**](docs/MarginApi.md#sapi_v1_margin_delist_schedule_get) | **GET** /sapi/v1/margin/delist-schedule | Get tokens or symbols delist schedule for cross margin and isolated margin (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_dribblet_get**](docs/MarginApi.md#sapi_v1_margin_dribblet_get) | **GET** /sapi/v1/margin/dribblet | Margin Dustlog (USER_DATA)
*MarginApi* | [**sapi_v1_margin_dust_get**](docs/MarginApi.md#sapi_v1_margin_dust_get) | **GET** /sapi/v1/margin/dust | Get Assets That Can Be Converted Into BNB (USER_DATA)
*MarginApi* | [**sapi_v1_margin_dust_post**](docs/MarginApi.md#sapi_v1_margin_dust_post) | **POST** /sapi/v1/margin/dust | Dust Transfer (TRADE)
*MarginApi* | [**sapi_v1_margin_exchange_small_liability_get**](docs/MarginApi.md#sapi_v1_margin_exchange_small_liability_get) | **GET** /sapi/v1/margin/exchange-small-liability | Get Small Liability Exchange Coin List (USER_DATA)
*MarginApi* | [**sapi_v1_margin_exchange_small_liability_history_get**](docs/MarginApi.md#sapi_v1_margin_exchange_small_liability_history_get) | **GET** /sapi/v1/margin/exchange-small-liability-history | Get Small Liability Exchange History (USER_DATA)
*MarginApi* | [**sapi_v1_margin_force_liquidation_rec_get**](docs/MarginApi.md#sapi_v1_margin_force_liquidation_rec_get) | **GET** /sapi/v1/margin/forceLiquidationRec | Get Force Liquidation Record (USER_DATA)
*MarginApi* | [**sapi_v1_margin_interest_history_get**](docs/MarginApi.md#sapi_v1_margin_interest_history_get) | **GET** /sapi/v1/margin/interestHistory | Get Interest History (USER_DATA)
*MarginApi* | [**sapi_v1_margin_interest_rate_history_get**](docs/MarginApi.md#sapi_v1_margin_interest_rate_history_get) | **GET** /sapi/v1/margin/interestRateHistory | Margin Interest Rate History (USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_account_delete**](docs/MarginApi.md#sapi_v1_margin_isolated_account_delete) | **DELETE** /sapi/v1/margin/isolated/account | Disable Isolated Margin Account (TRADE)
*MarginApi* | [**sapi_v1_margin_isolated_account_get**](docs/MarginApi.md#sapi_v1_margin_isolated_account_get) | **GET** /sapi/v1/margin/isolated/account | Query Isolated Margin Account Info (USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_account_limit_get**](docs/MarginApi.md#sapi_v1_margin_isolated_account_limit_get) | **GET** /sapi/v1/margin/isolated/accountLimit | Query Enabled Isolated Margin Account Limit (USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_account_post**](docs/MarginApi.md#sapi_v1_margin_isolated_account_post) | **POST** /sapi/v1/margin/isolated/account | Enable Isolated Margin Account (TRADE)
*MarginApi* | [**sapi_v1_margin_isolated_all_pairs_get**](docs/MarginApi.md#sapi_v1_margin_isolated_all_pairs_get) | **GET** /sapi/v1/margin/isolated/allPairs | Get All Isolated Margin Symbol(USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_margin_data_get**](docs/MarginApi.md#sapi_v1_margin_isolated_margin_data_get) | **GET** /sapi/v1/margin/isolatedMarginData | Query Isolated Margin Fee Data (USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_margin_tier_get**](docs/MarginApi.md#sapi_v1_margin_isolated_margin_tier_get) | **GET** /sapi/v1/margin/isolatedMarginTier | Query Isolated Margin Tier Data (USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_pair_get**](docs/MarginApi.md#sapi_v1_margin_isolated_pair_get) | **GET** /sapi/v1/margin/isolated/pair | Query Isolated Margin Symbol (USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_transfer_get**](docs/MarginApi.md#sapi_v1_margin_isolated_transfer_get) | **GET** /sapi/v1/margin/isolated/transfer | Get Isolated Margin Transfer History (USER_DATA)
*MarginApi* | [**sapi_v1_margin_isolated_transfer_post**](docs/MarginApi.md#sapi_v1_margin_isolated_transfer_post) | **POST** /sapi/v1/margin/isolated/transfer | Isolated Margin Account Transfer (MARGIN)
*MarginApi* | [**sapi_v1_margin_leverage_bracket_get**](docs/MarginApi.md#sapi_v1_margin_leverage_bracket_get) | **GET** /sapi/v1/margin/leverageBracket | Query Liability Coin Leverage Bracket in Cross Margin Pro Mode (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_loan_get**](docs/MarginApi.md#sapi_v1_margin_loan_get) | **GET** /sapi/v1/margin/loan | Query Loan Record (USER_DATA)
*MarginApi* | [**sapi_v1_margin_loan_post**](docs/MarginApi.md#sapi_v1_margin_loan_post) | **POST** /sapi/v1/margin/loan | Margin Account Borrow (MARGIN)
*MarginApi* | [**sapi_v1_margin_manual_liquidation_post**](docs/MarginApi.md#sapi_v1_margin_manual_liquidation_post) | **POST** /sapi/v1/margin/manual-liquidation | Margin manual liquidation(MARGIN)
*MarginApi* | [**sapi_v1_margin_max_borrowable_get**](docs/MarginApi.md#sapi_v1_margin_max_borrowable_get) | **GET** /sapi/v1/margin/maxBorrowable | Query Max Borrow (USER_DATA)
*MarginApi* | [**sapi_v1_margin_max_leverage_post**](docs/MarginApi.md#sapi_v1_margin_max_leverage_post) | **POST** /sapi/v1/margin/max-leverage | Adjust cross margin max leverage (USER_DATA)
*MarginApi* | [**sapi_v1_margin_max_transferable_get**](docs/MarginApi.md#sapi_v1_margin_max_transferable_get) | **GET** /sapi/v1/margin/maxTransferable | Query Max Transfer-Out Amount (USER_DATA)
*MarginApi* | [**sapi_v1_margin_my_trades_get**](docs/MarginApi.md#sapi_v1_margin_my_trades_get) | **GET** /sapi/v1/margin/myTrades | Query Margin Account&#x27;s Trade List (USER_DATA)
*MarginApi* | [**sapi_v1_margin_next_hourly_interest_rate_get**](docs/MarginApi.md#sapi_v1_margin_next_hourly_interest_rate_get) | **GET** /sapi/v1/margin/next-hourly-interest-rate | Get a future hourly interest rate (USER_DATA)
*MarginApi* | [**sapi_v1_margin_open_order_list_get**](docs/MarginApi.md#sapi_v1_margin_open_order_list_get) | **GET** /sapi/v1/margin/openOrderList | Query Margin Account&#x27;s Open OCO (USER_DATA)
*MarginApi* | [**sapi_v1_margin_open_orders_delete**](docs/MarginApi.md#sapi_v1_margin_open_orders_delete) | **DELETE** /sapi/v1/margin/openOrders | Margin Account Cancel all Open Orders on a Symbol (TRADE)
*MarginApi* | [**sapi_v1_margin_open_orders_get**](docs/MarginApi.md#sapi_v1_margin_open_orders_get) | **GET** /sapi/v1/margin/openOrders | Query Margin Account&#x27;s Open Orders (USER_DATA)
*MarginApi* | [**sapi_v1_margin_order_delete**](docs/MarginApi.md#sapi_v1_margin_order_delete) | **DELETE** /sapi/v1/margin/order | Margin Account Cancel Order (TRADE)
*MarginApi* | [**sapi_v1_margin_order_get**](docs/MarginApi.md#sapi_v1_margin_order_get) | **GET** /sapi/v1/margin/order | Query Margin Account&#x27;s Order (USER_DATA)
*MarginApi* | [**sapi_v1_margin_order_list_delete**](docs/MarginApi.md#sapi_v1_margin_order_list_delete) | **DELETE** /sapi/v1/margin/orderList | Margin Account Cancel OCO (TRADE)
*MarginApi* | [**sapi_v1_margin_order_list_get**](docs/MarginApi.md#sapi_v1_margin_order_list_get) | **GET** /sapi/v1/margin/orderList | Query Margin Account&#x27;s OCO (USER_DATA)
*MarginApi* | [**sapi_v1_margin_order_oco_post**](docs/MarginApi.md#sapi_v1_margin_order_oco_post) | **POST** /sapi/v1/margin/order/oco | Margin Account New OCO (TRADE)
*MarginApi* | [**sapi_v1_margin_order_post**](docs/MarginApi.md#sapi_v1_margin_order_post) | **POST** /sapi/v1/margin/order | Margin Account New Order (TRADE)
*MarginApi* | [**sapi_v1_margin_pair_get**](docs/MarginApi.md#sapi_v1_margin_pair_get) | **GET** /sapi/v1/margin/pair | Query Cross Margin Pair (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_price_index_get**](docs/MarginApi.md#sapi_v1_margin_price_index_get) | **GET** /sapi/v1/margin/priceIndex | Query Margin PriceIndex (MARKET_DATA)
*MarginApi* | [**sapi_v1_margin_rate_limit_order_get**](docs/MarginApi.md#sapi_v1_margin_rate_limit_order_get) | **GET** /sapi/v1/margin/rateLimit/order | Query Current Margin Order Count Usage (TRADE)
*MarginApi* | [**sapi_v1_margin_repay_get**](docs/MarginApi.md#sapi_v1_margin_repay_get) | **GET** /sapi/v1/margin/repay | Query Repay Record (USER_DATA)
*MarginApi* | [**sapi_v1_margin_repay_post**](docs/MarginApi.md#sapi_v1_margin_repay_post) | **POST** /sapi/v1/margin/repay | Margin Account Repay (MARGIN)
*MarginApi* | [**sapi_v1_margin_trade_coeff_get**](docs/MarginApi.md#sapi_v1_margin_trade_coeff_get) | **GET** /sapi/v1/margin/tradeCoeff | Get Summary of Margin account (USER_DATA)
*MarginApi* | [**sapi_v1_margin_transfer_get**](docs/MarginApi.md#sapi_v1_margin_transfer_get) | **GET** /sapi/v1/margin/transfer | Get Cross Margin Transfer History (USER_DATA)
*MarginApi* | [**sapi_v1_margin_transfer_post**](docs/MarginApi.md#sapi_v1_margin_transfer_post) | **POST** /sapi/v1/margin/transfer | Cross Margin Account Transfer (MARGIN)
*MarginStreamApi* | [**sapi_v1_user_data_stream_delete**](docs/MarginStreamApi.md#sapi_v1_user_data_stream_delete) | **DELETE** /sapi/v1/userDataStream | Close a ListenKey (USER_STREAM)
*MarginStreamApi* | [**sapi_v1_user_data_stream_post**](docs/MarginStreamApi.md#sapi_v1_user_data_stream_post) | **POST** /sapi/v1/userDataStream | Create a ListenKey (USER_STREAM)
*MarginStreamApi* | [**sapi_v1_user_data_stream_put**](docs/MarginStreamApi.md#sapi_v1_user_data_stream_put) | **PUT** /sapi/v1/userDataStream | Ping/Keep-alive a ListenKey (USER_STREAM)
*MarketApi* | [**api_v3_agg_trades_get**](docs/MarketApi.md#api_v3_agg_trades_get) | **GET** /api/v3/aggTrades | Compressed/Aggregate Trades List
*MarketApi* | [**api_v3_avg_price_get**](docs/MarketApi.md#api_v3_avg_price_get) | **GET** /api/v3/avgPrice | Current Average Price
*MarketApi* | [**api_v3_depth_get**](docs/MarketApi.md#api_v3_depth_get) | **GET** /api/v3/depth | Order Book
*MarketApi* | [**api_v3_exchange_info_get**](docs/MarketApi.md#api_v3_exchange_info_get) | **GET** /api/v3/exchangeInfo | Exchange Information
*MarketApi* | [**api_v3_historical_trades_get**](docs/MarketApi.md#api_v3_historical_trades_get) | **GET** /api/v3/historicalTrades | Old Trade Lookup
*MarketApi* | [**api_v3_klines_get**](docs/MarketApi.md#api_v3_klines_get) | **GET** /api/v3/klines | Kline/Candlestick Data
*MarketApi* | [**api_v3_ping_get**](docs/MarketApi.md#api_v3_ping_get) | **GET** /api/v3/ping | Test Connectivity
*MarketApi* | [**api_v3_ticker24hr_get**](docs/MarketApi.md#api_v3_ticker24hr_get) | **GET** /api/v3/ticker/24hr | 24hr Ticker Price Change Statistics
*MarketApi* | [**api_v3_ticker_book_ticker_get**](docs/MarketApi.md#api_v3_ticker_book_ticker_get) | **GET** /api/v3/ticker/bookTicker | Symbol Order Book Ticker
*MarketApi* | [**api_v3_ticker_get**](docs/MarketApi.md#api_v3_ticker_get) | **GET** /api/v3/ticker | Rolling window price change statistics
*MarketApi* | [**api_v3_ticker_price_get**](docs/MarketApi.md#api_v3_ticker_price_get) | **GET** /api/v3/ticker/price | Symbol Price Ticker
*MarketApi* | [**api_v3_time_get**](docs/MarketApi.md#api_v3_time_get) | **GET** /api/v3/time | Check Server Time
*MarketApi* | [**api_v3_trades_get**](docs/MarketApi.md#api_v3_trades_get) | **GET** /api/v3/trades | Recent Trades List
*MarketApi* | [**api_v3_ui_klines_get**](docs/MarketApi.md#api_v3_ui_klines_get) | **GET** /api/v3/uiKlines | UIKlines
*MiningApi* | [**sapi_v1_mining_hash_transfer_config_cancel_post**](docs/MiningApi.md#sapi_v1_mining_hash_transfer_config_cancel_post) | **POST** /sapi/v1/mining/hash-transfer/config/cancel | Cancel Hashrate Resale configuration (USER_DATA)
*MiningApi* | [**sapi_v1_mining_hash_transfer_config_details_list_get**](docs/MiningApi.md#sapi_v1_mining_hash_transfer_config_details_list_get) | **GET** /sapi/v1/mining/hash-transfer/config/details/list | Hashrate Resale List (USER_DATA)
*MiningApi* | [**sapi_v1_mining_hash_transfer_config_post**](docs/MiningApi.md#sapi_v1_mining_hash_transfer_config_post) | **POST** /sapi/v1/mining/hash-transfer/config | Hashrate Resale Request (USER_DATA)
*MiningApi* | [**sapi_v1_mining_hash_transfer_profit_details_get**](docs/MiningApi.md#sapi_v1_mining_hash_transfer_profit_details_get) | **GET** /sapi/v1/mining/hash-transfer/profit/details | Hashrate Resale Details (USER_DATA)
*MiningApi* | [**sapi_v1_mining_payment_list_get**](docs/MiningApi.md#sapi_v1_mining_payment_list_get) | **GET** /sapi/v1/mining/payment/list | Earnings List (USER_DATA)
*MiningApi* | [**sapi_v1_mining_payment_other_get**](docs/MiningApi.md#sapi_v1_mining_payment_other_get) | **GET** /sapi/v1/mining/payment/other | Extra Bonus List (USER_DATA)
*MiningApi* | [**sapi_v1_mining_payment_uid_get**](docs/MiningApi.md#sapi_v1_mining_payment_uid_get) | **GET** /sapi/v1/mining/payment/uid | Mining Account Earning (USER_DATA)
*MiningApi* | [**sapi_v1_mining_pub_algo_list_get**](docs/MiningApi.md#sapi_v1_mining_pub_algo_list_get) | **GET** /sapi/v1/mining/pub/algoList | Acquiring Algorithm (MARKET_DATA)
*MiningApi* | [**sapi_v1_mining_pub_coin_list_get**](docs/MiningApi.md#sapi_v1_mining_pub_coin_list_get) | **GET** /sapi/v1/mining/pub/coinList | Acquiring CoinName (MARKET_DATA)
*MiningApi* | [**sapi_v1_mining_statistics_user_list_get**](docs/MiningApi.md#sapi_v1_mining_statistics_user_list_get) | **GET** /sapi/v1/mining/statistics/user/list | Account List (USER_DATA)
*MiningApi* | [**sapi_v1_mining_statistics_user_status_get**](docs/MiningApi.md#sapi_v1_mining_statistics_user_status_get) | **GET** /sapi/v1/mining/statistics/user/status | Statistic List (USER_DATA)
*MiningApi* | [**sapi_v1_mining_worker_detail_get**](docs/MiningApi.md#sapi_v1_mining_worker_detail_get) | **GET** /sapi/v1/mining/worker/detail | Request for Detail Miner List (USER_DATA)
*MiningApi* | [**sapi_v1_mining_worker_list_get**](docs/MiningApi.md#sapi_v1_mining_worker_list_get) | **GET** /sapi/v1/mining/worker/list | Request for Miner List (USER_DATA)
*NFTApi* | [**sapi_v1_nft_history_deposit_get**](docs/NFTApi.md#sapi_v1_nft_history_deposit_get) | **GET** /sapi/v1/nft/history/deposit | Get NFT Deposit History(USER_DATA)
*NFTApi* | [**sapi_v1_nft_history_transactions_get**](docs/NFTApi.md#sapi_v1_nft_history_transactions_get) | **GET** /sapi/v1/nft/history/transactions | Get NFT Transaction History (USER_DATA)
*NFTApi* | [**sapi_v1_nft_history_withdraw_get**](docs/NFTApi.md#sapi_v1_nft_history_withdraw_get) | **GET** /sapi/v1/nft/history/withdraw | Get NFT Withdraw History (USER_DATA)
*NFTApi* | [**sapi_v1_nft_user_get_asset_get**](docs/NFTApi.md#sapi_v1_nft_user_get_asset_get) | **GET** /sapi/v1/nft/user/getAsset | Get NFT Asset (USER_DATA)
*PayApi* | [**sapi_v1_pay_transactions_get**](docs/PayApi.md#sapi_v1_pay_transactions_get) | **GET** /sapi/v1/pay/transactions | Get Pay Trade History (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_account_get**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_account_get) | **GET** /sapi/v1/portfolio/account | Portfolio Margin Account (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_asset_collection_post**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_asset_collection_post) | **POST** /sapi/v1/portfolio/asset-collection | Fund Collection by Asset (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_asset_index_price_get**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_asset_index_price_get) | **GET** /sapi/v1/portfolio/asset-index-price | Query Portfolio Margin Asset Index Price (MARKET_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_auto_collection_post**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_auto_collection_post) | **POST** /sapi/v1/portfolio/auto-collection | Fund Auto-collection (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_bnb_transfer_post**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_bnb_transfer_post) | **POST** /sapi/v1/portfolio/bnb-transfer | BNB Transfer (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_collateral_rate_get**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_collateral_rate_get) | **GET** /sapi/v1/portfolio/collateralRate | Portfolio Margin Collateral Rate (MARKET_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_interest_history_get**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_interest_history_get) | **GET** /sapi/v1/portfolio/interest-history | Query Classic Portfolio Margin Negative Balance Interest History (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_margin_asset_leverage_get**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_margin_asset_leverage_get) | **GET** /sapi/v1/portfolio/margin-asset-leverage | Get Portfolio Margin Asset Leverage (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_pm_loan_get**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_pm_loan_get) | **GET** /sapi/v1/portfolio/pmLoan | Portfolio Margin Bankruptcy Loan Amount (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_repay_futures_negative_balance_post**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_repay_futures_negative_balance_post) | **POST** /sapi/v1/portfolio/repay-futures-negative-balance | Repay futures Negative Balance (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_repay_futures_switch_get**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_repay_futures_switch_get) | **GET** /sapi/v1/portfolio/repay-futures-switch | Get Auto-repay-futures Status (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_repay_futures_switch_post**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_repay_futures_switch_post) | **POST** /sapi/v1/portfolio/repay-futures-switch | Change Auto-repay-futures Status (USER_DATA)
*PortfolioMarginApi* | [**sapi_v1_portfolio_repay_post**](docs/PortfolioMarginApi.md#sapi_v1_portfolio_repay_post) | **POST** /sapi/v1/portfolio/repay | Portfolio Margin Bankruptcy Loan Repay (USER_DATA)
*RebateApi* | [**sapi_v1_rebate_tax_query_get**](docs/RebateApi.md#sapi_v1_rebate_tax_query_get) | **GET** /sapi/v1/rebate/taxQuery | Get Spot Rebate History Records (USER_DATA)
*SavingsApi* | [**sapi_v1_lending_customized_fixed_purchase_post**](docs/SavingsApi.md#sapi_v1_lending_customized_fixed_purchase_post) | **POST** /sapi/v1/lending/customizedFixed/purchase | Purchase Fixed/Activity Project (USER_DATA)
*SavingsApi* | [**sapi_v1_lending_position_changed_post**](docs/SavingsApi.md#sapi_v1_lending_position_changed_post) | **POST** /sapi/v1/lending/positionChanged | Change Fixed/Activity Position to Daily Position (USER_DATA)
*SavingsApi* | [**sapi_v1_lending_project_list_get**](docs/SavingsApi.md#sapi_v1_lending_project_list_get) | **GET** /sapi/v1/lending/project/list | Get Fixed/Activity Project List(USER_DATA)
*SavingsApi* | [**sapi_v1_lending_project_position_list_get**](docs/SavingsApi.md#sapi_v1_lending_project_position_list_get) | **GET** /sapi/v1/lending/project/position/list | Get Fixed/Activity Project Position (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_account_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_account_get) | **GET** /sapi/v1/simple-earn/account | Simple Account (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_history_collateral_record_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_history_collateral_record_get) | **GET** /sapi/v1/simple-earn/flexible/history/collateralRecord | Get Collateral Record (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_history_rate_history_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_history_rate_history_get) | **GET** /sapi/v1/simple-earn/flexible/history/rateHistory | Get Rate History (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_history_redemption_record_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_history_redemption_record_get) | **GET** /sapi/v1/simple-earn/flexible/history/redemptionRecord | Get Flexible Redemption Record (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_history_rewards_record_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_history_rewards_record_get) | **GET** /sapi/v1/simple-earn/flexible/history/rewardsRecord | Get Flexible Rewards History (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_history_subscription_record_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_history_subscription_record_get) | **GET** /sapi/v1/simple-earn/flexible/history/subscriptionRecord | Get Flexible Subscription Record (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_list_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_list_get) | **GET** /sapi/v1/simple-earn/flexible/list | Get Simple Earn Flexible Product List (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_personal_left_quota_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_personal_left_quota_get) | **GET** /sapi/v1/simple-earn/flexible/personalLeftQuota | Get Flexible Personal Left Quota (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_position_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_position_get) | **GET** /sapi/v1/simple-earn/flexible/position | Get Flexible Product Position (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_redeem_post**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_redeem_post) | **POST** /sapi/v1/simple-earn/flexible/redeem | Redeem Flexible Product (TRADE)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_set_auto_subscribe_post**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_set_auto_subscribe_post) | **POST** /sapi/v1/simple-earn/flexible/setAutoSubscribe | Set Flexible Auto Subscribe (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_subscribe_post**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_subscribe_post) | **POST** /sapi/v1/simple-earn/flexible/subscribe | Subscribe Flexible Product (TRADE)
*SimpleEarnApi* | [**sapi_v1_simple_earn_flexible_subscription_preview_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_flexible_subscription_preview_get) | **GET** /sapi/v1/simple-earn/flexible/subscriptionPreview | Get Flexible Subscription Preview (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_history_redemption_record_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_history_redemption_record_get) | **GET** /sapi/v1/simple-earn/locked/history/redemptionRecord | Get Locked Redemption Record (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_history_rewards_record_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_history_rewards_record_get) | **GET** /sapi/v1/simple-earn/locked/history/rewardsRecord | Get Locked Rewards History (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_history_subscription_record_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_history_subscription_record_get) | **GET** /sapi/v1/simple-earn/locked/history/subscriptionRecord | Get Locked Subscription Record (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_list_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_list_get) | **GET** /sapi/v1/simple-earn/locked/list | Get Simple Earn Locked Product List (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_personal_left_quota_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_personal_left_quota_get) | **GET** /sapi/v1/simple-earn/locked/personalLeftQuota | Get Locked Personal Left Quota (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_position_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_position_get) | **GET** /sapi/v1/simple-earn/locked/position | Get Locked Product Position (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_redeem_post**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_redeem_post) | **POST** /sapi/v1/simple-earn/locked/redeem | Redeem Locked Product (TRADE)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_set_auto_subscribe_post**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_set_auto_subscribe_post) | **POST** /sapi/v1/simple-earn/locked/setAutoSubscribe | Set Locked Auto Subscribe (USER_DATA)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_subscribe_post**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_subscribe_post) | **POST** /sapi/v1/simple-earn/locked/subscribe | Subscribe Locked Product (TRADE)
*SimpleEarnApi* | [**sapi_v1_simple_earn_locked_subscription_preview_get**](docs/SimpleEarnApi.md#sapi_v1_simple_earn_locked_subscription_preview_get) | **GET** /sapi/v1/simple-earn/locked/subscriptionPreview | Get Locked Subscription Preview (USER_DATA)
*SpotAlgoApi* | [**sapi_v1_algo_spot_historical_orders_get**](docs/SpotAlgoApi.md#sapi_v1_algo_spot_historical_orders_get) | **GET** /sapi/v1/algo/spot/historicalOrders | Query Historical Algo Orders
*SpotAlgoApi* | [**sapi_v1_algo_spot_new_order_twap_post**](docs/SpotAlgoApi.md#sapi_v1_algo_spot_new_order_twap_post) | **POST** /sapi/v1/algo/spot/newOrderTwap | Time-Weighted Average Price (Twap) New Order
*SpotAlgoApi* | [**sapi_v1_algo_spot_open_orders_get**](docs/SpotAlgoApi.md#sapi_v1_algo_spot_open_orders_get) | **GET** /sapi/v1/algo/spot/openOrders | Query Current Algo Open Orders
*SpotAlgoApi* | [**sapi_v1_algo_spot_order_delete**](docs/SpotAlgoApi.md#sapi_v1_algo_spot_order_delete) | **DELETE** /sapi/v1/algo/spot/order | Cancel Algo Order
*SpotAlgoApi* | [**sapi_v1_algo_spot_sub_orders_get**](docs/SpotAlgoApi.md#sapi_v1_algo_spot_sub_orders_get) | **GET** /sapi/v1/algo/spot/subOrders | Query Sub Orders
*StakingApi* | [**sapi_v1_staking_personal_left_quota_get**](docs/StakingApi.md#sapi_v1_staking_personal_left_quota_get) | **GET** /sapi/v1/staking/personalLeftQuota | Get Personal Left Quota of Staking Product (USER_DATA)
*StakingApi* | [**sapi_v1_staking_position_get**](docs/StakingApi.md#sapi_v1_staking_position_get) | **GET** /sapi/v1/staking/position | Get Staking Product Position (USER_DATA)
*StakingApi* | [**sapi_v1_staking_product_list_get**](docs/StakingApi.md#sapi_v1_staking_product_list_get) | **GET** /sapi/v1/staking/productList | Get Staking Product List (USER_DATA)
*StakingApi* | [**sapi_v1_staking_purchase_post**](docs/StakingApi.md#sapi_v1_staking_purchase_post) | **POST** /sapi/v1/staking/purchase | Purchase Staking Product (USER_DATA)
*StakingApi* | [**sapi_v1_staking_redeem_post**](docs/StakingApi.md#sapi_v1_staking_redeem_post) | **POST** /sapi/v1/staking/redeem | Redeem Staking Product (USER_DATA)
*StakingApi* | [**sapi_v1_staking_set_auto_staking_post**](docs/StakingApi.md#sapi_v1_staking_set_auto_staking_post) | **POST** /sapi/v1/staking/setAutoStaking | Set Auto Staking (USER_DATA)
*StakingApi* | [**sapi_v1_staking_staking_record_get**](docs/StakingApi.md#sapi_v1_staking_staking_record_get) | **GET** /sapi/v1/staking/stakingRecord | Get Staking History (USER_DATA)
*StreamApi* | [**api_v3_user_data_stream_delete**](docs/StreamApi.md#api_v3_user_data_stream_delete) | **DELETE** /api/v3/userDataStream | Close a ListenKey (USER_STREAM)
*StreamApi* | [**api_v3_user_data_stream_post**](docs/StreamApi.md#api_v3_user_data_stream_post) | **POST** /api/v3/userDataStream | Create a ListenKey (USER_STREAM)
*StreamApi* | [**api_v3_user_data_stream_put**](docs/StreamApi.md#api_v3_user_data_stream_put) | **PUT** /api/v3/userDataStream | Ping/Keep-alive a ListenKey (USER_STREAM)
*SubAccountApi* | [**sapi_v1_capital_deposit_sub_address_get**](docs/SubAccountApi.md#sapi_v1_capital_deposit_sub_address_get) | **GET** /sapi/v1/capital/deposit/subAddress | Sub-account Spot Assets Summary (For Master Account)
*SubAccountApi* | [**sapi_v1_capital_deposit_sub_hisrec_get**](docs/SubAccountApi.md#sapi_v1_capital_deposit_sub_hisrec_get) | **GET** /sapi/v1/capital/deposit/subHisrec | Sub-account Deposit History (For Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_account_snapshot_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_account_snapshot_get) | **GET** /sapi/v1/managed-subaccount/accountSnapshot | Managed sub-account snapshot (For Investor Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_asset_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_asset_get) | **GET** /sapi/v1/managed-subaccount/asset | Managed sub-account asset details(For Investor Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_deposit_address_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_deposit_address_get) | **GET** /sapi/v1/managed-subaccount/deposit/address | Get Managed Sub-account Deposit Address (For Investor Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_deposit_post**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_deposit_post) | **POST** /sapi/v1/managed-subaccount/deposit | Deposit assets into the managed sub-account(For Investor Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_fetch_future_asset_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_fetch_future_asset_get) | **GET** /sapi/v1/managed-subaccount/fetch-future-asset | Query Managed Sub-account Futures Asset Details (For Investor Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_info_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_info_get) | **GET** /sapi/v1/managed-subaccount/info | Query Managed Sub-account List (For Investor)
*SubAccountApi* | [**sapi_v1_managed_subaccount_margin_asset_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_margin_asset_get) | **GET** /sapi/v1/managed-subaccount/marginAsset | Query Managed Sub-account Margin Asset Details (For Investor Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_query_trans_log_for_investor_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_query_trans_log_for_investor_get) | **GET** /sapi/v1/managed-subaccount/queryTransLogForInvestor | Query Managed Sub Account Transfer Log (For Investor Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_query_trans_log_for_trade_parent_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_query_trans_log_for_trade_parent_get) | **GET** /sapi/v1/managed-subaccount/queryTransLogForTradeParent | Query Managed Sub Account Transfer Log (For Trading Team Master Account)
*SubAccountApi* | [**sapi_v1_managed_subaccount_query_trans_log_get**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_query_trans_log_get) | **GET** /sapi/v1/managed-subaccount/query-trans-log | Query Managed Sub Account Transfer Log (For Trading Team Sub Account)(USER_DATA)
*SubAccountApi* | [**sapi_v1_managed_subaccount_withdraw_post**](docs/SubAccountApi.md#sapi_v1_managed_subaccount_withdraw_post) | **POST** /sapi/v1/managed-subaccount/withdraw | Withdrawl assets from the managed sub-account(For Investor Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_blvt_enable_post**](docs/SubAccountApi.md#sapi_v1_sub_account_blvt_enable_post) | **POST** /sapi/v1/sub-account/blvt/enable | Enable Leverage Token for Sub-account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_eoptions_enable_post**](docs/SubAccountApi.md#sapi_v1_sub_account_eoptions_enable_post) | **POST** /sapi/v1/sub-account/eoptions/enable | Enable Options for Sub-account (For Master Account)(USER_DATA)
*SubAccountApi* | [**sapi_v1_sub_account_futures_account_get**](docs/SubAccountApi.md#sapi_v1_sub_account_futures_account_get) | **GET** /sapi/v1/sub-account/futures/account | Detail on Sub-account&#x27;s Futures Account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_futures_account_summary_get**](docs/SubAccountApi.md#sapi_v1_sub_account_futures_account_summary_get) | **GET** /sapi/v1/sub-account/futures/accountSummary | Summary of Sub-account&#x27;s Futures Account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_futures_enable_post**](docs/SubAccountApi.md#sapi_v1_sub_account_futures_enable_post) | **POST** /sapi/v1/sub-account/futures/enable | Enable Futures for Sub-account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_futures_internal_transfer_get**](docs/SubAccountApi.md#sapi_v1_sub_account_futures_internal_transfer_get) | **GET** /sapi/v1/sub-account/futures/internalTransfer | Sub-account Futures Asset Transfer History (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_futures_internal_transfer_post**](docs/SubAccountApi.md#sapi_v1_sub_account_futures_internal_transfer_post) | **POST** /sapi/v1/sub-account/futures/internalTransfer | Sub-account Futures Asset Transfer (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_futures_position_risk_get**](docs/SubAccountApi.md#sapi_v1_sub_account_futures_position_risk_get) | **GET** /sapi/v1/sub-account/futures/positionRisk | Futures Position-Risk of Sub-account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_futures_transfer_post**](docs/SubAccountApi.md#sapi_v1_sub_account_futures_transfer_post) | **POST** /sapi/v1/sub-account/futures/transfer | Transfer for Sub-account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_list_get**](docs/SubAccountApi.md#sapi_v1_sub_account_list_get) | **GET** /sapi/v1/sub-account/list | Query Sub-account List (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_margin_account_get**](docs/SubAccountApi.md#sapi_v1_sub_account_margin_account_get) | **GET** /sapi/v1/sub-account/margin/account | Detail on Sub-account&#x27;s Margin Account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_margin_account_summary_get**](docs/SubAccountApi.md#sapi_v1_sub_account_margin_account_summary_get) | **GET** /sapi/v1/sub-account/margin/accountSummary | Summary of Sub-account&#x27;s Margin Account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_margin_enable_post**](docs/SubAccountApi.md#sapi_v1_sub_account_margin_enable_post) | **POST** /sapi/v1/sub-account/margin/enable | Enable Margin for Sub-account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_margin_transfer_post**](docs/SubAccountApi.md#sapi_v1_sub_account_margin_transfer_post) | **POST** /sapi/v1/sub-account/margin/transfer | Margin Transfer for Sub-account (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_spot_summary_get**](docs/SubAccountApi.md#sapi_v1_sub_account_spot_summary_get) | **GET** /sapi/v1/sub-account/spotSummary | Sub-account Spot Assets Summary (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_status_get**](docs/SubAccountApi.md#sapi_v1_sub_account_status_get) | **GET** /sapi/v1/sub-account/status | Sub-account&#x27;s Status on Margin/Futures (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_sub_account_api_ip_restriction_get**](docs/SubAccountApi.md#sapi_v1_sub_account_sub_account_api_ip_restriction_get) | **GET** /sapi/v1/sub-account/subAccountApi/ipRestriction | Get IP Restriction for a Sub-account API Key (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_sub_account_api_ip_restriction_ip_list_delete**](docs/SubAccountApi.md#sapi_v1_sub_account_sub_account_api_ip_restriction_ip_list_delete) | **DELETE** /sapi/v1/sub-account/subAccountApi/ipRestriction/ipList | Delete IP List for a Sub-account API Key (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_sub_transfer_history_get**](docs/SubAccountApi.md#sapi_v1_sub_account_sub_transfer_history_get) | **GET** /sapi/v1/sub-account/sub/transfer/history | Sub-account Spot Asset Transfer History (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_transaction_statistics_get**](docs/SubAccountApi.md#sapi_v1_sub_account_transaction_statistics_get) | **GET** /sapi/v1/sub-account/transaction-statistics | Query Sub-account Transaction Statistics (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_transfer_sub_to_master_post**](docs/SubAccountApi.md#sapi_v1_sub_account_transfer_sub_to_master_post) | **POST** /sapi/v1/sub-account/transfer/subToMaster | Transfer to Master (For Sub-account)
*SubAccountApi* | [**sapi_v1_sub_account_transfer_sub_to_sub_post**](docs/SubAccountApi.md#sapi_v1_sub_account_transfer_sub_to_sub_post) | **POST** /sapi/v1/sub-account/transfer/subToSub | Transfer to Sub-account of Same Master (For Sub-account)
*SubAccountApi* | [**sapi_v1_sub_account_transfer_sub_user_history_get**](docs/SubAccountApi.md#sapi_v1_sub_account_transfer_sub_user_history_get) | **GET** /sapi/v1/sub-account/transfer/subUserHistory | Sub-account Transfer History (For Sub-account)
*SubAccountApi* | [**sapi_v1_sub_account_universal_transfer_get**](docs/SubAccountApi.md#sapi_v1_sub_account_universal_transfer_get) | **GET** /sapi/v1/sub-account/universalTransfer | Universal Transfer History (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_universal_transfer_post**](docs/SubAccountApi.md#sapi_v1_sub_account_universal_transfer_post) | **POST** /sapi/v1/sub-account/universalTransfer | Universal Transfer (For Master Account)
*SubAccountApi* | [**sapi_v1_sub_account_virtual_sub_account_post**](docs/SubAccountApi.md#sapi_v1_sub_account_virtual_sub_account_post) | **POST** /sapi/v1/sub-account/virtualSubAccount | Create a Virtual Sub-account(For Master Account)
*SubAccountApi* | [**sapi_v2_sub_account_futures_account_get**](docs/SubAccountApi.md#sapi_v2_sub_account_futures_account_get) | **GET** /sapi/v2/sub-account/futures/account | Detail on Sub-account&#x27;s Futures Account V2 (For Master Account)
*SubAccountApi* | [**sapi_v2_sub_account_futures_account_summary_get**](docs/SubAccountApi.md#sapi_v2_sub_account_futures_account_summary_get) | **GET** /sapi/v2/sub-account/futures/accountSummary | Summary of Sub-account&#x27;s Futures Account V2 (For Master Account)
*SubAccountApi* | [**sapi_v2_sub_account_futures_position_risk_get**](docs/SubAccountApi.md#sapi_v2_sub_account_futures_position_risk_get) | **GET** /sapi/v2/sub-account/futures/positionRisk | Futures Position-Risk of Sub-account V2 (For Master Account)
*SubAccountApi* | [**sapi_v2_sub_account_sub_account_api_ip_restriction_post**](docs/SubAccountApi.md#sapi_v2_sub_account_sub_account_api_ip_restriction_post) | **POST** /sapi/v2/sub-account/subAccountApi/ipRestriction | Update IP Restriction for Sub-Account API key (For Master Account)
*SubAccountApi* | [**sapi_v3_sub_account_assets_get**](docs/SubAccountApi.md#sapi_v3_sub_account_assets_get) | **GET** /sapi/v3/sub-account/assets | Sub-account Assets (For Master Account)
*SubAccountApi* | [**sapi_v4_sub_account_assets_get**](docs/SubAccountApi.md#sapi_v4_sub_account_assets_get) | **GET** /sapi/v4/sub-account/assets | Query Sub-account Assets (For Master Account)
*TradeApi* | [**api_v3_account_get**](docs/TradeApi.md#api_v3_account_get) | **GET** /api/v3/account | Account Information (USER_DATA)
*TradeApi* | [**api_v3_all_order_list_get**](docs/TradeApi.md#api_v3_all_order_list_get) | **GET** /api/v3/allOrderList | Query all OCO (USER_DATA)
*TradeApi* | [**api_v3_all_orders_get**](docs/TradeApi.md#api_v3_all_orders_get) | **GET** /api/v3/allOrders | All Orders (USER_DATA)
*TradeApi* | [**api_v3_my_allocations_get**](docs/TradeApi.md#api_v3_my_allocations_get) | **GET** /api/v3/myAllocations | Query Allocations (USER_DATA)
*TradeApi* | [**api_v3_my_prevented_matches_get**](docs/TradeApi.md#api_v3_my_prevented_matches_get) | **GET** /api/v3/myPreventedMatches | Query Prevented Matches
*TradeApi* | [**api_v3_my_trades_get**](docs/TradeApi.md#api_v3_my_trades_get) | **GET** /api/v3/myTrades | Account Trade List (USER_DATA)
*TradeApi* | [**api_v3_open_order_list_get**](docs/TradeApi.md#api_v3_open_order_list_get) | **GET** /api/v3/openOrderList | Query Open OCO (USER_DATA)
*TradeApi* | [**api_v3_open_orders_delete**](docs/TradeApi.md#api_v3_open_orders_delete) | **DELETE** /api/v3/openOrders | Cancel all Open Orders on a Symbol (TRADE)
*TradeApi* | [**api_v3_open_orders_get**](docs/TradeApi.md#api_v3_open_orders_get) | **GET** /api/v3/openOrders | Current Open Orders (USER_DATA)
*TradeApi* | [**api_v3_order_cancel_replace_post**](docs/TradeApi.md#api_v3_order_cancel_replace_post) | **POST** /api/v3/order/cancelReplace | Cancel an Existing Order and Send a New Order (Trade)
*TradeApi* | [**api_v3_order_delete**](docs/TradeApi.md#api_v3_order_delete) | **DELETE** /api/v3/order | Cancel Order (TRADE)
*TradeApi* | [**api_v3_order_get**](docs/TradeApi.md#api_v3_order_get) | **GET** /api/v3/order | Query Order (USER_DATA)
*TradeApi* | [**api_v3_order_list_delete**](docs/TradeApi.md#api_v3_order_list_delete) | **DELETE** /api/v3/orderList | Cancel OCO (TRADE)
*TradeApi* | [**api_v3_order_list_get**](docs/TradeApi.md#api_v3_order_list_get) | **GET** /api/v3/orderList | Query OCO (USER_DATA)
*TradeApi* | [**api_v3_order_oco_post**](docs/TradeApi.md#api_v3_order_oco_post) | **POST** /api/v3/order/oco | New OCO (TRADE)
*TradeApi* | [**api_v3_order_post**](docs/TradeApi.md#api_v3_order_post) | **POST** /api/v3/order | New Order (TRADE)
*TradeApi* | [**api_v3_order_test_post**](docs/TradeApi.md#api_v3_order_test_post) | **POST** /api/v3/order/test | Test New Order (TRADE)
*TradeApi* | [**api_v3_rate_limit_order_get**](docs/TradeApi.md#api_v3_rate_limit_order_get) | **GET** /api/v3/rateLimit/order | Query Current Order Count Usage (TRADE)
*TradeApi* | [**api_v3_sor_order_post**](docs/TradeApi.md#api_v3_sor_order_post) | **POST** /api/v3/sor/order | New order using SOR (TRADE)
*TradeApi* | [**api_v3_sor_order_test_post**](docs/TradeApi.md#api_v3_sor_order_test_post) | **POST** /api/v3/sor/order/test | Test new order using SOR (TRADE)
*VIPLoansApi* | [**sapi_v1_loan_vip_borrow_post**](docs/VIPLoansApi.md#sapi_v1_loan_vip_borrow_post) | **POST** /sapi/v1/loan/vip/borrow | VIP Loan Borrow
*VIPLoansApi* | [**sapi_v1_loan_vip_collateral_account_get**](docs/VIPLoansApi.md#sapi_v1_loan_vip_collateral_account_get) | **GET** /sapi/v1/loan/vip/collateral/account | Check Locked Value of VIP Collateral Account (USER_DATA)
*VIPLoansApi* | [**sapi_v1_loan_vip_collateral_data_get**](docs/VIPLoansApi.md#sapi_v1_loan_vip_collateral_data_get) | **GET** /sapi/v1/loan/vip/collateral/data | Get Collateral Asset Data (USER_DATA)
*VIPLoansApi* | [**sapi_v1_loan_vip_loanable_data_get**](docs/VIPLoansApi.md#sapi_v1_loan_vip_loanable_data_get) | **GET** /sapi/v1/loan/vip/loanable/data | Get Loanable Assets Data
*VIPLoansApi* | [**sapi_v1_loan_vip_ongoing_orders_get**](docs/VIPLoansApi.md#sapi_v1_loan_vip_ongoing_orders_get) | **GET** /sapi/v1/loan/vip/ongoing/orders | Get VIP Loan Ongoing Orders (USER_DATA)
*VIPLoansApi* | [**sapi_v1_loan_vip_renew_post**](docs/VIPLoansApi.md#sapi_v1_loan_vip_renew_post) | **POST** /sapi/v1/loan/vip/renew | VIP Loan Renew
*VIPLoansApi* | [**sapi_v1_loan_vip_repay_history_get**](docs/VIPLoansApi.md#sapi_v1_loan_vip_repay_history_get) | **GET** /sapi/v1/loan/vip/repay/history | Get VIP Loan Repayment History (USER_DATA)
*VIPLoansApi* | [**sapi_v1_loan_vip_repay_post**](docs/VIPLoansApi.md#sapi_v1_loan_vip_repay_post) | **POST** /sapi/v1/loan/vip/repay | VIP Loan Repay (TRADE)
*VIPLoansApi* | [**sapi_v1_loan_vip_request_data_get**](docs/VIPLoansApi.md#sapi_v1_loan_vip_request_data_get) | **GET** /sapi/v1/loan/vip/request/data | Query Application Status (USER_DATA)
*VIPLoansApi* | [**sapi_v1_loan_vip_request_interest_rate_get**](docs/VIPLoansApi.md#sapi_v1_loan_vip_request_interest_rate_get) | **GET** /sapi/v1/loan/vip/request/interestRate | Get Borrow Interest Rate (USER_DATA)
*WalletApi* | [**sapi_v1_account_api_restrictions_get**](docs/WalletApi.md#sapi_v1_account_api_restrictions_get) | **GET** /sapi/v1/account/apiRestrictions | Get API Key Permission (USER_DATA)
*WalletApi* | [**sapi_v1_account_api_trading_status_get**](docs/WalletApi.md#sapi_v1_account_api_trading_status_get) | **GET** /sapi/v1/account/apiTradingStatus | Account API Trading Status (USER_DATA)
*WalletApi* | [**sapi_v1_account_disable_fast_withdraw_switch_post**](docs/WalletApi.md#sapi_v1_account_disable_fast_withdraw_switch_post) | **POST** /sapi/v1/account/disableFastWithdrawSwitch | Disable Fast Withdraw Switch (USER_DATA)
*WalletApi* | [**sapi_v1_account_enable_fast_withdraw_switch_post**](docs/WalletApi.md#sapi_v1_account_enable_fast_withdraw_switch_post) | **POST** /sapi/v1/account/enableFastWithdrawSwitch | Enable Fast Withdraw Switch (USER_DATA)
*WalletApi* | [**sapi_v1_account_snapshot_get**](docs/WalletApi.md#sapi_v1_account_snapshot_get) | **GET** /sapi/v1/accountSnapshot | Daily Account Snapshot (USER_DATA)
*WalletApi* | [**sapi_v1_account_status_get**](docs/WalletApi.md#sapi_v1_account_status_get) | **GET** /sapi/v1/account/status | Account Status (USER_DATA)
*WalletApi* | [**sapi_v1_asset_asset_detail_get**](docs/WalletApi.md#sapi_v1_asset_asset_detail_get) | **GET** /sapi/v1/asset/assetDetail | Asset Detail (USER_DATA)
*WalletApi* | [**sapi_v1_asset_asset_dividend_get**](docs/WalletApi.md#sapi_v1_asset_asset_dividend_get) | **GET** /sapi/v1/asset/assetDividend | Asset Dividend Record (USER_DATA)
*WalletApi* | [**sapi_v1_asset_convert_transfer_post**](docs/WalletApi.md#sapi_v1_asset_convert_transfer_post) | **POST** /sapi/v1/asset/convert-transfer | Convert Transfer (USER_DATA)
*WalletApi* | [**sapi_v1_asset_convert_transfer_query_by_page_get**](docs/WalletApi.md#sapi_v1_asset_convert_transfer_query_by_page_get) | **GET** /sapi/v1/asset/convert-transfer/queryByPage | Query Convert Transfer (USER_DATA)
*WalletApi* | [**sapi_v1_asset_custody_transfer_history_get**](docs/WalletApi.md#sapi_v1_asset_custody_transfer_history_get) | **GET** /sapi/v1/asset/custody/transfer-history | Query User Delegation History(For Master Account) (USER_DATA)
*WalletApi* | [**sapi_v1_asset_dribblet_get**](docs/WalletApi.md#sapi_v1_asset_dribblet_get) | **GET** /sapi/v1/asset/dribblet | DustLog(USER_DATA)
*WalletApi* | [**sapi_v1_asset_dust_btc_post**](docs/WalletApi.md#sapi_v1_asset_dust_btc_post) | **POST** /sapi/v1/asset/dust-btc | Get Assets That Can Be Converted Into BNB (USER_DATA)
*WalletApi* | [**sapi_v1_asset_dust_post**](docs/WalletApi.md#sapi_v1_asset_dust_post) | **POST** /sapi/v1/asset/dust | Dust Transfer (USER_DATA)
*WalletApi* | [**sapi_v1_asset_get_funding_asset_post**](docs/WalletApi.md#sapi_v1_asset_get_funding_asset_post) | **POST** /sapi/v1/asset/get-funding-asset | Funding Wallet (USER_DATA)
*WalletApi* | [**sapi_v1_asset_ledger_transfer_cloud_mining_query_by_page_get**](docs/WalletApi.md#sapi_v1_asset_ledger_transfer_cloud_mining_query_by_page_get) | **GET** /sapi/v1/asset/ledger-transfer/cloud-mining/queryByPage | Get Cloud-Mining payment and refund history (USER_DATA)
*WalletApi* | [**sapi_v1_asset_trade_fee_get**](docs/WalletApi.md#sapi_v1_asset_trade_fee_get) | **GET** /sapi/v1/asset/tradeFee | Trade Fee (USER_DATA)
*WalletApi* | [**sapi_v1_asset_transfer_get**](docs/WalletApi.md#sapi_v1_asset_transfer_get) | **GET** /sapi/v1/asset/transfer | Query User Universal Transfer History (USER_DATA)
*WalletApi* | [**sapi_v1_asset_transfer_post**](docs/WalletApi.md#sapi_v1_asset_transfer_post) | **POST** /sapi/v1/asset/transfer | User Universal Transfer (USER_DATA)
*WalletApi* | [**sapi_v1_asset_wallet_balance_get**](docs/WalletApi.md#sapi_v1_asset_wallet_balance_get) | **GET** /sapi/v1/asset/wallet/balance | Query User Wallet Balance (USER_DATA)
*WalletApi* | [**sapi_v1_capital_config_getall_get**](docs/WalletApi.md#sapi_v1_capital_config_getall_get) | **GET** /sapi/v1/capital/config/getall | All Coins&#x27; Information (USER_DATA)
*WalletApi* | [**sapi_v1_capital_contract_convertible_coins_get**](docs/WalletApi.md#sapi_v1_capital_contract_convertible_coins_get) | **GET** /sapi/v1/capital/contract/convertible-coins | Query auto-converting stable coins (USER_DATA)
*WalletApi* | [**sapi_v1_capital_contract_convertible_coins_post**](docs/WalletApi.md#sapi_v1_capital_contract_convertible_coins_post) | **POST** /sapi/v1/capital/contract/convertible-coins | Switch on/off BUSD and stable coins conversion (USER_DATA) (USER_DATA)
*WalletApi* | [**sapi_v1_capital_deposit_address_get**](docs/WalletApi.md#sapi_v1_capital_deposit_address_get) | **GET** /sapi/v1/capital/deposit/address | Deposit Address (supporting network) (USER_DATA)
*WalletApi* | [**sapi_v1_capital_deposit_address_list_get**](docs/WalletApi.md#sapi_v1_capital_deposit_address_list_get) | **GET** /sapi/v1/capital/deposit/address/list | Fetch deposit address list with network (USER_DATA)
*WalletApi* | [**sapi_v1_capital_deposit_credit_apply_post**](docs/WalletApi.md#sapi_v1_capital_deposit_credit_apply_post) | **POST** /sapi/v1/capital/deposit/credit-apply | One click arrival deposit apply (USER_DATA)
*WalletApi* | [**sapi_v1_capital_deposit_hisrec_get**](docs/WalletApi.md#sapi_v1_capital_deposit_hisrec_get) | **GET** /sapi/v1/capital/deposit/hisrec | Deposit History(supporting network) (USER_DATA)
*WalletApi* | [**sapi_v1_capital_withdraw_apply_post**](docs/WalletApi.md#sapi_v1_capital_withdraw_apply_post) | **POST** /sapi/v1/capital/withdraw/apply | Withdraw (USER_DATA)
*WalletApi* | [**sapi_v1_capital_withdraw_history_get**](docs/WalletApi.md#sapi_v1_capital_withdraw_history_get) | **GET** /sapi/v1/capital/withdraw/history | Withdraw History (supporting network) (USER_DATA)
*WalletApi* | [**sapi_v1_system_status_get**](docs/WalletApi.md#sapi_v1_system_status_get) | **GET** /sapi/v1/system/status | System Status (System)
*WalletApi* | [**sapi_v3_asset_get_user_asset_post**](docs/WalletApi.md#sapi_v3_asset_get_user_asset_post) | **POST** /sapi/v3/asset/getUserAsset | User Asset (USER_DATA)

## Documentation For Models

 - [Account](docs/Account.md)
 - [AccountBalances](docs/AccountBalances.md)
 - [AccountCommissionRates](docs/AccountCommissionRates.md)
 - [AggTrade](docs/AggTrade.md)
 - [Apiv3allOrderListOrders](docs/Apiv3allOrderListOrders.md)
 - [Apiv3openOrderListOrders](docs/Apiv3openOrderListOrders.md)
 - [BnbBurnStatus](docs/BnbBurnStatus.md)
 - [BookTicker](docs/BookTicker.md)
 - [BookTickerList](docs/BookTickerList.md)
 - [BswapAddLiquidityPreviewCombination](docs/BswapAddLiquidityPreviewCombination.md)
 - [BswapAddLiquidityPreviewSingle](docs/BswapAddLiquidityPreviewSingle.md)
 - [BswapRmvLiquidityPreviewCombination](docs/BswapRmvLiquidityPreviewCombination.md)
 - [BswapRmvLiquidityPreviewSingle](docs/BswapRmvLiquidityPreviewSingle.md)
 - [CanceledMarginOrderDetail](docs/CanceledMarginOrderDetail.md)
 - [Details](docs/Details.md)
 - [Details1](docs/Details1.md)
 - [Details2](docs/Details2.md)
 - [Error](docs/Error.md)
 - [InlineResponse200](docs/InlineResponse200.md)
 - [InlineResponse2001](docs/InlineResponse2001.md)
 - [InlineResponse20010](docs/InlineResponse20010.md)
 - [InlineResponse200100](docs/InlineResponse200100.md)
 - [InlineResponse200101](docs/InlineResponse200101.md)
 - [InlineResponse200102](docs/InlineResponse200102.md)
 - [InlineResponse200103](docs/InlineResponse200103.md)
 - [InlineResponse200104](docs/InlineResponse200104.md)
 - [InlineResponse200105](docs/InlineResponse200105.md)
 - [InlineResponse200106](docs/InlineResponse200106.md)
 - [InlineResponse200107](docs/InlineResponse200107.md)
 - [InlineResponse200108](docs/InlineResponse200108.md)
 - [InlineResponse200109](docs/InlineResponse200109.md)
 - [InlineResponse20010OrderReports](docs/InlineResponse20010OrderReports.md)
 - [InlineResponse20010Orders](docs/InlineResponse20010Orders.md)
 - [InlineResponse20011](docs/InlineResponse20011.md)
 - [InlineResponse200110](docs/InlineResponse200110.md)
 - [InlineResponse200111](docs/InlineResponse200111.md)
 - [InlineResponse200111Data](docs/InlineResponse200111Data.md)
 - [InlineResponse200111DataBalances](docs/InlineResponse200111DataBalances.md)
 - [InlineResponse200111SnapshotVos](docs/InlineResponse200111SnapshotVos.md)
 - [InlineResponse200112](docs/InlineResponse200112.md)
 - [InlineResponse200112ManagerSubTransferHistoryVos](docs/InlineResponse200112ManagerSubTransferHistoryVos.md)
 - [InlineResponse200113](docs/InlineResponse200113.md)
 - [InlineResponse200113Data](docs/InlineResponse200113Data.md)
 - [InlineResponse200113DataAssets](docs/InlineResponse200113DataAssets.md)
 - [InlineResponse200113DataPosition](docs/InlineResponse200113DataPosition.md)
 - [InlineResponse200113SnapshotVos](docs/InlineResponse200113SnapshotVos.md)
 - [InlineResponse200114](docs/InlineResponse200114.md)
 - [InlineResponse200114UserAssets](docs/InlineResponse200114UserAssets.md)
 - [InlineResponse200115](docs/InlineResponse200115.md)
 - [InlineResponse200115ManagerSubUserInfoVoList](docs/InlineResponse200115ManagerSubUserInfoVoList.md)
 - [InlineResponse200116](docs/InlineResponse200116.md)
 - [InlineResponse200117](docs/InlineResponse200117.md)
 - [InlineResponse200117ManagerSubTransferHistoryVos](docs/InlineResponse200117ManagerSubTransferHistoryVos.md)
 - [InlineResponse200118](docs/InlineResponse200118.md)
 - [InlineResponse200119](docs/InlineResponse200119.md)
 - [InlineResponse20011Orders](docs/InlineResponse20011Orders.md)
 - [InlineResponse20012](docs/InlineResponse20012.md)
 - [InlineResponse200120](docs/InlineResponse200120.md)
 - [InlineResponse200120TradeInfoVos](docs/InlineResponse200120TradeInfoVos.md)
 - [InlineResponse200121](docs/InlineResponse200121.md)
 - [InlineResponse200122](docs/InlineResponse200122.md)
 - [InlineResponse200123](docs/InlineResponse200123.md)
 - [InlineResponse200123Balances](docs/InlineResponse200123Balances.md)
 - [InlineResponse200124](docs/InlineResponse200124.md)
 - [InlineResponse200125](docs/InlineResponse200125.md)
 - [InlineResponse200126](docs/InlineResponse200126.md)
 - [InlineResponse200126Data](docs/InlineResponse200126Data.md)
 - [InlineResponse200127](docs/InlineResponse200127.md)
 - [InlineResponse200127Data](docs/InlineResponse200127Data.md)
 - [InlineResponse200128](docs/InlineResponse200128.md)
 - [InlineResponse200129](docs/InlineResponse200129.md)
 - [InlineResponse20013](docs/InlineResponse20013.md)
 - [InlineResponse200130](docs/InlineResponse200130.md)
 - [InlineResponse200131](docs/InlineResponse200131.md)
 - [InlineResponse200132](docs/InlineResponse200132.md)
 - [InlineResponse200133](docs/InlineResponse200133.md)
 - [InlineResponse200134](docs/InlineResponse200134.md)
 - [InlineResponse200135](docs/InlineResponse200135.md)
 - [InlineResponse200136](docs/InlineResponse200136.md)
 - [InlineResponse200137](docs/InlineResponse200137.md)
 - [InlineResponse200137Data](docs/InlineResponse200137Data.md)
 - [InlineResponse200138](docs/InlineResponse200138.md)
 - [InlineResponse200138Data](docs/InlineResponse200138Data.md)
 - [InlineResponse200139](docs/InlineResponse200139.md)
 - [InlineResponse200139Data](docs/InlineResponse200139Data.md)
 - [InlineResponse200139HashrateDatas](docs/InlineResponse200139HashrateDatas.md)
 - [InlineResponse20014](docs/InlineResponse20014.md)
 - [InlineResponse200140](docs/InlineResponse200140.md)
 - [InlineResponse200140Data](docs/InlineResponse200140Data.md)
 - [InlineResponse200140DataWorkerDatas](docs/InlineResponse200140DataWorkerDatas.md)
 - [InlineResponse200141](docs/InlineResponse200141.md)
 - [InlineResponse200141Data](docs/InlineResponse200141Data.md)
 - [InlineResponse200141DataAccountProfits](docs/InlineResponse200141DataAccountProfits.md)
 - [InlineResponse200142](docs/InlineResponse200142.md)
 - [InlineResponse200142Data](docs/InlineResponse200142Data.md)
 - [InlineResponse200142DataOtherProfits](docs/InlineResponse200142DataOtherProfits.md)
 - [InlineResponse200143](docs/InlineResponse200143.md)
 - [InlineResponse200143Data](docs/InlineResponse200143Data.md)
 - [InlineResponse200143DataConfigDetails](docs/InlineResponse200143DataConfigDetails.md)
 - [InlineResponse200144](docs/InlineResponse200144.md)
 - [InlineResponse200144Data](docs/InlineResponse200144Data.md)
 - [InlineResponse200144DataProfitTransferDetails](docs/InlineResponse200144DataProfitTransferDetails.md)
 - [InlineResponse200145](docs/InlineResponse200145.md)
 - [InlineResponse200146](docs/InlineResponse200146.md)
 - [InlineResponse200147](docs/InlineResponse200147.md)
 - [InlineResponse200147Data](docs/InlineResponse200147Data.md)
 - [InlineResponse200147DataProfitToday](docs/InlineResponse200147DataProfitToday.md)
 - [InlineResponse200148](docs/InlineResponse200148.md)
 - [InlineResponse200148Data](docs/InlineResponse200148Data.md)
 - [InlineResponse200148List](docs/InlineResponse200148List.md)
 - [InlineResponse200149](docs/InlineResponse200149.md)
 - [InlineResponse200149Data](docs/InlineResponse200149Data.md)
 - [InlineResponse200149DataAccountProfits](docs/InlineResponse200149DataAccountProfits.md)
 - [InlineResponse20014Fills](docs/InlineResponse20014Fills.md)
 - [InlineResponse20015](docs/InlineResponse20015.md)
 - [InlineResponse200150](docs/InlineResponse200150.md)
 - [InlineResponse200150Rows](docs/InlineResponse200150Rows.md)
 - [InlineResponse200151](docs/InlineResponse200151.md)
 - [InlineResponse200152](docs/InlineResponse200152.md)
 - [InlineResponse200152Data](docs/InlineResponse200152Data.md)
 - [InlineResponse200153](docs/InlineResponse200153.md)
 - [InlineResponse200154](docs/InlineResponse200154.md)
 - [InlineResponse200155](docs/InlineResponse200155.md)
 - [InlineResponse200155Orders](docs/InlineResponse200155Orders.md)
 - [InlineResponse200156](docs/InlineResponse200156.md)
 - [InlineResponse200156Orders](docs/InlineResponse200156Orders.md)
 - [InlineResponse200157](docs/InlineResponse200157.md)
 - [InlineResponse200157SubOrders](docs/InlineResponse200157SubOrders.md)
 - [InlineResponse200158](docs/InlineResponse200158.md)
 - [InlineResponse200159](docs/InlineResponse200159.md)
 - [InlineResponse20016](docs/InlineResponse20016.md)
 - [InlineResponse200160](docs/InlineResponse200160.md)
 - [InlineResponse200160Orders](docs/InlineResponse200160Orders.md)
 - [InlineResponse200161](docs/InlineResponse200161.md)
 - [InlineResponse200161Orders](docs/InlineResponse200161Orders.md)
 - [InlineResponse200162](docs/InlineResponse200162.md)
 - [InlineResponse200162SubOrders](docs/InlineResponse200162SubOrders.md)
 - [InlineResponse200163](docs/InlineResponse200163.md)
 - [InlineResponse200164](docs/InlineResponse200164.md)
 - [InlineResponse200165](docs/InlineResponse200165.md)
 - [InlineResponse200166](docs/InlineResponse200166.md)
 - [InlineResponse200167](docs/InlineResponse200167.md)
 - [InlineResponse200168](docs/InlineResponse200168.md)
 - [InlineResponse200169](docs/InlineResponse200169.md)
 - [InlineResponse20017](docs/InlineResponse20017.md)
 - [InlineResponse200170](docs/InlineResponse200170.md)
 - [InlineResponse200171](docs/InlineResponse200171.md)
 - [InlineResponse200172](docs/InlineResponse200172.md)
 - [InlineResponse200173](docs/InlineResponse200173.md)
 - [InlineResponse200174](docs/InlineResponse200174.md)
 - [InlineResponse200175](docs/InlineResponse200175.md)
 - [InlineResponse200176](docs/InlineResponse200176.md)
 - [InlineResponse200177](docs/InlineResponse200177.md)
 - [InlineResponse200178](docs/InlineResponse200178.md)
 - [InlineResponse200179](docs/InlineResponse200179.md)
 - [InlineResponse20018](docs/InlineResponse20018.md)
 - [InlineResponse200180](docs/InlineResponse200180.md)
 - [InlineResponse200181](docs/InlineResponse200181.md)
 - [InlineResponse200182](docs/InlineResponse200182.md)
 - [InlineResponse200183](docs/InlineResponse200183.md)
 - [InlineResponse200184](docs/InlineResponse200184.md)
 - [InlineResponse200185](docs/InlineResponse200185.md)
 - [InlineResponse200186](docs/InlineResponse200186.md)
 - [InlineResponse200187](docs/InlineResponse200187.md)
 - [InlineResponse200188](docs/InlineResponse200188.md)
 - [InlineResponse200188Details](docs/InlineResponse200188Details.md)
 - [InlineResponse200188DetailsBNBBTC](docs/InlineResponse200188DetailsBNBBTC.md)
 - [InlineResponse200188DetailsBNBUSDT](docs/InlineResponse200188DetailsBNBUSDT.md)
 - [InlineResponse200188TotalUnclaimedRewards](docs/InlineResponse200188TotalUnclaimedRewards.md)
 - [InlineResponse200189](docs/InlineResponse200189.md)
 - [InlineResponse20018Rows](docs/InlineResponse20018Rows.md)
 - [InlineResponse20019](docs/InlineResponse20019.md)
 - [InlineResponse200190](docs/InlineResponse200190.md)
 - [InlineResponse200191](docs/InlineResponse200191.md)
 - [InlineResponse200191Data](docs/InlineResponse200191Data.md)
 - [InlineResponse200192](docs/InlineResponse200192.md)
 - [InlineResponse200192Rows](docs/InlineResponse200192Rows.md)
 - [InlineResponse200193](docs/InlineResponse200193.md)
 - [InlineResponse200194](docs/InlineResponse200194.md)
 - [InlineResponse200194Rows](docs/InlineResponse200194Rows.md)
 - [InlineResponse200195](docs/InlineResponse200195.md)
 - [InlineResponse200195Rows](docs/InlineResponse200195Rows.md)
 - [InlineResponse200196](docs/InlineResponse200196.md)
 - [InlineResponse200197](docs/InlineResponse200197.md)
 - [InlineResponse200197Rows](docs/InlineResponse200197Rows.md)
 - [InlineResponse200198](docs/InlineResponse200198.md)
 - [InlineResponse200198Rows](docs/InlineResponse200198Rows.md)
 - [InlineResponse200199](docs/InlineResponse200199.md)
 - [InlineResponse200199Rows](docs/InlineResponse200199Rows.md)
 - [InlineResponse20019Rows](docs/InlineResponse20019Rows.md)
 - [InlineResponse2001Filters](docs/InlineResponse2001Filters.md)
 - [InlineResponse2001RateLimits](docs/InlineResponse2001RateLimits.md)
 - [InlineResponse2001Symbols](docs/InlineResponse2001Symbols.md)
 - [InlineResponse2002](docs/InlineResponse2002.md)
 - [InlineResponse20020](docs/InlineResponse20020.md)
 - [InlineResponse200200](docs/InlineResponse200200.md)
 - [InlineResponse200201](docs/InlineResponse200201.md)
 - [InlineResponse200202](docs/InlineResponse200202.md)
 - [InlineResponse200203](docs/InlineResponse200203.md)
 - [InlineResponse200204](docs/InlineResponse200204.md)
 - [InlineResponse200204Rows](docs/InlineResponse200204Rows.md)
 - [InlineResponse200205](docs/InlineResponse200205.md)
 - [InlineResponse200205Rows](docs/InlineResponse200205Rows.md)
 - [InlineResponse200206](docs/InlineResponse200206.md)
 - [InlineResponse200207](docs/InlineResponse200207.md)
 - [InlineResponse200207Rows](docs/InlineResponse200207Rows.md)
 - [InlineResponse200208](docs/InlineResponse200208.md)
 - [InlineResponse200209](docs/InlineResponse200209.md)
 - [InlineResponse200209Rows](docs/InlineResponse200209Rows.md)
 - [InlineResponse20020Rows](docs/InlineResponse20020Rows.md)
 - [InlineResponse20021](docs/InlineResponse20021.md)
 - [InlineResponse200210](docs/InlineResponse200210.md)
 - [InlineResponse200210Rows](docs/InlineResponse200210Rows.md)
 - [InlineResponse200211](docs/InlineResponse200211.md)
 - [InlineResponse200211Rows](docs/InlineResponse200211Rows.md)
 - [InlineResponse200212](docs/InlineResponse200212.md)
 - [InlineResponse200213](docs/InlineResponse200213.md)
 - [InlineResponse200213Rows](docs/InlineResponse200213Rows.md)
 - [InlineResponse200214](docs/InlineResponse200214.md)
 - [InlineResponse200215](docs/InlineResponse200215.md)
 - [InlineResponse200215Rows](docs/InlineResponse200215Rows.md)
 - [InlineResponse200216](docs/InlineResponse200216.md)
 - [InlineResponse200216Rows](docs/InlineResponse200216Rows.md)
 - [InlineResponse200217](docs/InlineResponse200217.md)
 - [InlineResponse200218](docs/InlineResponse200218.md)
 - [InlineResponse200218Rows](docs/InlineResponse200218Rows.md)
 - [InlineResponse200219](docs/InlineResponse200219.md)
 - [InlineResponse20022](docs/InlineResponse20022.md)
 - [InlineResponse200220](docs/InlineResponse200220.md)
 - [InlineResponse200220Rows](docs/InlineResponse200220Rows.md)
 - [InlineResponse200221](docs/InlineResponse200221.md)
 - [InlineResponse200221Rows](docs/InlineResponse200221Rows.md)
 - [InlineResponse200222](docs/InlineResponse200222.md)
 - [InlineResponse200222Rows](docs/InlineResponse200222Rows.md)
 - [InlineResponse200223](docs/InlineResponse200223.md)
 - [InlineResponse200223Data](docs/InlineResponse200223Data.md)
 - [InlineResponse200223FundsDetail](docs/InlineResponse200223FundsDetail.md)
 - [InlineResponse200223PayerInfo](docs/InlineResponse200223PayerInfo.md)
 - [InlineResponse200223ReceiverInfo](docs/InlineResponse200223ReceiverInfo.md)
 - [InlineResponse200223ReceiverInfoExtend](docs/InlineResponse200223ReceiverInfoExtend.md)
 - [InlineResponse200224](docs/InlineResponse200224.md)
 - [InlineResponse200225](docs/InlineResponse200225.md)
 - [InlineResponse200226](docs/InlineResponse200226.md)
 - [InlineResponse200227](docs/InlineResponse200227.md)
 - [InlineResponse200228](docs/InlineResponse200228.md)
 - [InlineResponse200229](docs/InlineResponse200229.md)
 - [InlineResponse200229List](docs/InlineResponse200229List.md)
 - [InlineResponse20023](docs/InlineResponse20023.md)
 - [InlineResponse200230](docs/InlineResponse200230.md)
 - [InlineResponse200230Data](docs/InlineResponse200230Data.md)
 - [InlineResponse200230DataData](docs/InlineResponse200230DataData.md)
 - [InlineResponse200231](docs/InlineResponse200231.md)
 - [InlineResponse200231List](docs/InlineResponse200231List.md)
 - [InlineResponse200231Tokens](docs/InlineResponse200231Tokens.md)
 - [InlineResponse200232](docs/InlineResponse200232.md)
 - [InlineResponse200232List](docs/InlineResponse200232List.md)
 - [InlineResponse200233](docs/InlineResponse200233.md)
 - [InlineResponse200233List](docs/InlineResponse200233List.md)
 - [InlineResponse200234](docs/InlineResponse200234.md)
 - [InlineResponse200234List](docs/InlineResponse200234List.md)
 - [InlineResponse200235](docs/InlineResponse200235.md)
 - [InlineResponse200235Data](docs/InlineResponse200235Data.md)
 - [InlineResponse200236](docs/InlineResponse200236.md)
 - [InlineResponse200236Data](docs/InlineResponse200236Data.md)
 - [InlineResponse200237](docs/InlineResponse200237.md)
 - [InlineResponse200237Data](docs/InlineResponse200237Data.md)
 - [InlineResponse200238](docs/InlineResponse200238.md)
 - [InlineResponse200239](docs/InlineResponse200239.md)
 - [InlineResponse200239Data](docs/InlineResponse200239Data.md)
 - [InlineResponse20024](docs/InlineResponse20024.md)
 - [InlineResponse200240](docs/InlineResponse200240.md)
 - [InlineResponse200240AutoInvestAssetList](docs/InlineResponse200240AutoInvestAssetList.md)
 - [InlineResponse200240RoiAndDimensionTypeList](docs/InlineResponse200240RoiAndDimensionTypeList.md)
 - [InlineResponse200241](docs/InlineResponse200241.md)
 - [InlineResponse200242](docs/InlineResponse200242.md)
 - [InlineResponse200243](docs/InlineResponse200243.md)
 - [InlineResponse200243SourceAssets](docs/InlineResponse200243SourceAssets.md)
 - [InlineResponse200244](docs/InlineResponse200244.md)
 - [InlineResponse200245](docs/InlineResponse200245.md)
 - [InlineResponse200246](docs/InlineResponse200246.md)
 - [InlineResponse200246Plan](docs/InlineResponse200246Plan.md)
 - [InlineResponse200247](docs/InlineResponse200247.md)
 - [InlineResponse200247Details](docs/InlineResponse200247Details.md)
 - [InlineResponse200247Plan](docs/InlineResponse200247Plan.md)
 - [InlineResponse200248](docs/InlineResponse200248.md)
 - [InlineResponse200249](docs/InlineResponse200249.md)
 - [InlineResponse200249AssetAllocation](docs/InlineResponse200249AssetAllocation.md)
 - [InlineResponse20025](docs/InlineResponse20025.md)
 - [InlineResponse200250](docs/InlineResponse200250.md)
 - [InlineResponse200250AssetAllocation](docs/InlineResponse200250AssetAllocation.md)
 - [InlineResponse200250Details](docs/InlineResponse200250Details.md)
 - [InlineResponse200251](docs/InlineResponse200251.md)
 - [InlineResponse200252](docs/InlineResponse200252.md)
 - [InlineResponse200253](docs/InlineResponse200253.md)
 - [InlineResponse200254](docs/InlineResponse200254.md)
 - [InlineResponse200255](docs/InlineResponse200255.md)
 - [InlineResponse200256](docs/InlineResponse200256.md)
 - [InlineResponse200256Rows](docs/InlineResponse200256Rows.md)
 - [InlineResponse200256TierAnnualPercentageRate](docs/InlineResponse200256TierAnnualPercentageRate.md)
 - [InlineResponse200257](docs/InlineResponse200257.md)
 - [InlineResponse200257Detail](docs/InlineResponse200257Detail.md)
 - [InlineResponse200257Rows](docs/InlineResponse200257Rows.md)
 - [InlineResponse200258](docs/InlineResponse200258.md)
 - [InlineResponse200259](docs/InlineResponse200259.md)
 - [InlineResponse20026](docs/InlineResponse20026.md)
 - [InlineResponse200260](docs/InlineResponse200260.md)
 - [InlineResponse200261](docs/InlineResponse200261.md)
 - [InlineResponse200261Rows](docs/InlineResponse200261Rows.md)
 - [InlineResponse200262](docs/InlineResponse200262.md)
 - [InlineResponse200262Rows](docs/InlineResponse200262Rows.md)
 - [InlineResponse200263](docs/InlineResponse200263.md)
 - [InlineResponse200264](docs/InlineResponse200264.md)
 - [InlineResponse200264Rows](docs/InlineResponse200264Rows.md)
 - [InlineResponse200265](docs/InlineResponse200265.md)
 - [InlineResponse200265Rows](docs/InlineResponse200265Rows.md)
 - [InlineResponse200266](docs/InlineResponse200266.md)
 - [InlineResponse200266Rows](docs/InlineResponse200266Rows.md)
 - [InlineResponse200267](docs/InlineResponse200267.md)
 - [InlineResponse200267Rows](docs/InlineResponse200267Rows.md)
 - [InlineResponse200268](docs/InlineResponse200268.md)
 - [InlineResponse200268Rows](docs/InlineResponse200268Rows.md)
 - [InlineResponse200269](docs/InlineResponse200269.md)
 - [InlineResponse200269Rows](docs/InlineResponse200269Rows.md)
 - [InlineResponse20027](docs/InlineResponse20027.md)
 - [InlineResponse200270](docs/InlineResponse200270.md)
 - [InlineResponse200271](docs/InlineResponse200271.md)
 - [InlineResponse200272](docs/InlineResponse200272.md)
 - [InlineResponse200272Rows](docs/InlineResponse200272Rows.md)
 - [InlineResponse200273](docs/InlineResponse200273.md)
 - [InlineResponse200273Rows](docs/InlineResponse200273Rows.md)
 - [InlineResponse20027Rows](docs/InlineResponse20027Rows.md)
 - [InlineResponse20028](docs/InlineResponse20028.md)
 - [InlineResponse20028Rows](docs/InlineResponse20028Rows.md)
 - [InlineResponse20029](docs/InlineResponse20029.md)
 - [InlineResponse20029UserAssets](docs/InlineResponse20029UserAssets.md)
 - [InlineResponse2003](docs/InlineResponse2003.md)
 - [InlineResponse20030](docs/InlineResponse20030.md)
 - [InlineResponse20030OrderReports](docs/InlineResponse20030OrderReports.md)
 - [InlineResponse20031](docs/InlineResponse20031.md)
 - [InlineResponse20032](docs/InlineResponse20032.md)
 - [InlineResponse20033](docs/InlineResponse20033.md)
 - [InlineResponse20034](docs/InlineResponse20034.md)
 - [InlineResponse20035](docs/InlineResponse20035.md)
 - [InlineResponse20036](docs/InlineResponse20036.md)
 - [InlineResponse20037](docs/InlineResponse20037.md)
 - [InlineResponse20038](docs/InlineResponse20038.md)
 - [InlineResponse20039](docs/InlineResponse20039.md)
 - [InlineResponse2004](docs/InlineResponse2004.md)
 - [InlineResponse20040](docs/InlineResponse20040.md)
 - [InlineResponse20041](docs/InlineResponse20041.md)
 - [InlineResponse20042](docs/InlineResponse20042.md)
 - [InlineResponse20043](docs/InlineResponse20043.md)
 - [InlineResponse20044](docs/InlineResponse20044.md)
 - [InlineResponse20044UserAssetDribbletDetails](docs/InlineResponse20044UserAssetDribbletDetails.md)
 - [InlineResponse20044UserAssetDribblets](docs/InlineResponse20044UserAssetDribblets.md)
 - [InlineResponse20045](docs/InlineResponse20045.md)
 - [InlineResponse20046](docs/InlineResponse20046.md)
 - [InlineResponse20047](docs/InlineResponse20047.md)
 - [InlineResponse20047Rows](docs/InlineResponse20047Rows.md)
 - [InlineResponse20048](docs/InlineResponse20048.md)
 - [InlineResponse20049](docs/InlineResponse20049.md)
 - [InlineResponse2005](docs/InlineResponse2005.md)
 - [InlineResponse20050](docs/InlineResponse20050.md)
 - [InlineResponse20051](docs/InlineResponse20051.md)
 - [InlineResponse20051Assets](docs/InlineResponse20051Assets.md)
 - [InlineResponse20052](docs/InlineResponse20052.md)
 - [InlineResponse20052Details](docs/InlineResponse20052Details.md)
 - [InlineResponse20053](docs/InlineResponse20053.md)
 - [InlineResponse20053TransferResult](docs/InlineResponse20053TransferResult.md)
 - [InlineResponse20054](docs/InlineResponse20054.md)
 - [InlineResponse20055](docs/InlineResponse20055.md)
 - [InlineResponse20056](docs/InlineResponse20056.md)
 - [InlineResponse20057](docs/InlineResponse20057.md)
 - [InlineResponse20058](docs/InlineResponse20058.md)
 - [InlineResponse20059](docs/InlineResponse20059.md)
 - [InlineResponse2006](docs/InlineResponse2006.md)
 - [InlineResponse20060](docs/InlineResponse20060.md)
 - [InlineResponse20061](docs/InlineResponse20061.md)
 - [InlineResponse20062](docs/InlineResponse20062.md)
 - [InlineResponse20063](docs/InlineResponse20063.md)
 - [InlineResponse20064](docs/InlineResponse20064.md)
 - [InlineResponse20064Data](docs/InlineResponse20064Data.md)
 - [InlineResponse20064DataIndicators](docs/InlineResponse20064DataIndicators.md)
 - [InlineResponse20064DataIndicatorsBTCUSDT](docs/InlineResponse20064DataIndicatorsBTCUSDT.md)
 - [InlineResponse20064DataTriggerCondition](docs/InlineResponse20064DataTriggerCondition.md)
 - [InlineResponse20065](docs/InlineResponse20065.md)
 - [InlineResponse20065UserAssetDribblets](docs/InlineResponse20065UserAssetDribblets.md)
 - [InlineResponse20066](docs/InlineResponse20066.md)
 - [InlineResponse20066Details](docs/InlineResponse20066Details.md)
 - [InlineResponse20067](docs/InlineResponse20067.md)
 - [InlineResponse20067TransferResult](docs/InlineResponse20067TransferResult.md)
 - [InlineResponse20068](docs/InlineResponse20068.md)
 - [InlineResponse20068Rows](docs/InlineResponse20068Rows.md)
 - [InlineResponse20069](docs/InlineResponse20069.md)
 - [InlineResponse20069CTR](docs/InlineResponse20069CTR.md)
 - [InlineResponse2007](docs/InlineResponse2007.md)
 - [InlineResponse20070](docs/InlineResponse20070.md)
 - [InlineResponse20071](docs/InlineResponse20071.md)
 - [InlineResponse20071Rows](docs/InlineResponse20071Rows.md)
 - [InlineResponse20072](docs/InlineResponse20072.md)
 - [InlineResponse20073](docs/InlineResponse20073.md)
 - [InlineResponse20074](docs/InlineResponse20074.md)
 - [InlineResponse20075](docs/InlineResponse20075.md)
 - [InlineResponse20076](docs/InlineResponse20076.md)
 - [InlineResponse20076Rows](docs/InlineResponse20076Rows.md)
 - [InlineResponse20077](docs/InlineResponse20077.md)
 - [InlineResponse20077Rows](docs/InlineResponse20077Rows.md)
 - [InlineResponse20078](docs/InlineResponse20078.md)
 - [InlineResponse20079](docs/InlineResponse20079.md)
 - [InlineResponse20079ExchangeRates](docs/InlineResponse20079ExchangeRates.md)
 - [InlineResponse2008](docs/InlineResponse2008.md)
 - [InlineResponse20080](docs/InlineResponse20080.md)
 - [InlineResponse20081](docs/InlineResponse20081.md)
 - [InlineResponse20081SubAccounts](docs/InlineResponse20081SubAccounts.md)
 - [InlineResponse20082](docs/InlineResponse20082.md)
 - [InlineResponse20083](docs/InlineResponse20083.md)
 - [InlineResponse20083Transfers](docs/InlineResponse20083Transfers.md)
 - [InlineResponse20084](docs/InlineResponse20084.md)
 - [InlineResponse20085](docs/InlineResponse20085.md)
 - [InlineResponse20085Balances](docs/InlineResponse20085Balances.md)
 - [InlineResponse20086](docs/InlineResponse20086.md)
 - [InlineResponse20086SpotSubUserAssetBtcVoList](docs/InlineResponse20086SpotSubUserAssetBtcVoList.md)
 - [InlineResponse20087](docs/InlineResponse20087.md)
 - [InlineResponse20088](docs/InlineResponse20088.md)
 - [InlineResponse20089](docs/InlineResponse20089.md)
 - [InlineResponse2009](docs/InlineResponse2009.md)
 - [InlineResponse20090](docs/InlineResponse20090.md)
 - [InlineResponse20091](docs/InlineResponse20091.md)
 - [InlineResponse20091Rows](docs/InlineResponse20091Rows.md)
 - [InlineResponse20092](docs/InlineResponse20092.md)
 - [InlineResponse20093](docs/InlineResponse20093.md)
 - [InlineResponse20094](docs/InlineResponse20094.md)
 - [InlineResponse20095](docs/InlineResponse20095.md)
 - [InlineResponse20095MarginTradeCoeffVo](docs/InlineResponse20095MarginTradeCoeffVo.md)
 - [InlineResponse20096](docs/InlineResponse20096.md)
 - [InlineResponse20096SubAccountList](docs/InlineResponse20096SubAccountList.md)
 - [InlineResponse20097](docs/InlineResponse20097.md)
 - [InlineResponse20098](docs/InlineResponse20098.md)
 - [InlineResponse20099](docs/InlineResponse20099.md)
 - [InlineResponse20099SubAccountList](docs/InlineResponse20099SubAccountList.md)
 - [InlineResponse2009CancelResponse](docs/InlineResponse2009CancelResponse.md)
 - [InlineResponse2009NewOrderResponse](docs/InlineResponse2009NewOrderResponse.md)
 - [IsolatedMarginAccountInfo](docs/IsolatedMarginAccountInfo.md)
 - [IsolatedMarginAccountInfoAssets](docs/IsolatedMarginAccountInfoAssets.md)
 - [IsolatedMarginAccountInfoBaseAsset](docs/IsolatedMarginAccountInfoBaseAsset.md)
 - [IsolatedMarginAccountInfoQuoteAsset](docs/IsolatedMarginAccountInfoQuoteAsset.md)
 - [MarginOcoOrder](docs/MarginOcoOrder.md)
 - [MarginOcoOrderOrderReports](docs/MarginOcoOrderOrderReports.md)
 - [MarginOcoOrderOrders](docs/MarginOcoOrderOrders.md)
 - [MarginOrder](docs/MarginOrder.md)
 - [MarginOrderDetail](docs/MarginOrderDetail.md)
 - [MarginOrderResponseAck](docs/MarginOrderResponseAck.md)
 - [MarginOrderResponseFull](docs/MarginOrderResponseFull.md)
 - [MarginOrderResponseResult](docs/MarginOrderResponseResult.md)
 - [MarginTrade](docs/MarginTrade.md)
 - [MarginTransferDetails](docs/MarginTransferDetails.md)
 - [MarginTransferDetailsRows](docs/MarginTransferDetailsRows.md)
 - [MyTrade](docs/MyTrade.md)
 - [OcoOrder](docs/OcoOrder.md)
 - [OcoOrderOrderReports](docs/OcoOrderOrderReports.md)
 - [OcoOrderOrders](docs/OcoOrderOrders.md)
 - [Order](docs/Order.md)
 - [OrderDetails](docs/OrderDetails.md)
 - [OrderResponseAck](docs/OrderResponseAck.md)
 - [OrderResponseFull](docs/OrderResponseFull.md)
 - [OrderResponseFullFills](docs/OrderResponseFullFills.md)
 - [OrderResponseResult](docs/OrderResponseResult.md)
 - [PriceTicker](docs/PriceTicker.md)
 - [PriceTickerList](docs/PriceTickerList.md)
 - [RepaymentInfo](docs/RepaymentInfo.md)
 - [RepaymentInfo2](docs/RepaymentInfo2.md)
 - [Sapiv1blvttokenInfoCurrentBaskets](docs/Sapiv1blvttokenInfoCurrentBaskets.md)
 - [Sapiv1bswapliquidityLiquidity](docs/Sapiv1bswapliquidityLiquidity.md)
 - [Sapiv1bswapliquidityShare](docs/Sapiv1bswapliquidityShare.md)
 - [Sapiv1bswapliquidityShareAsset](docs/Sapiv1bswapliquidityShareAsset.md)
 - [Sapiv1bswappoolConfigureAssetConfigure](docs/Sapiv1bswappoolConfigureAssetConfigure.md)
 - [Sapiv1bswappoolConfigureAssetConfigureBUSD](docs/Sapiv1bswappoolConfigureAssetConfigureBUSD.md)
 - [Sapiv1bswappoolConfigureLiquidity](docs/Sapiv1bswappoolConfigureLiquidity.md)
 - [Sapiv1capitalconfiggetallNetworkList](docs/Sapiv1capitalconfiggetallNetworkList.md)
 - [Sapiv1lendingautoinvestrebalancehistoryTransactionDetails](docs/Sapiv1lendingautoinvestrebalancehistoryTransactionDetails.md)
 - [Sapiv1margincrossMarginCollateralRatioCollaterals](docs/Sapiv1margincrossMarginCollateralRatioCollaterals.md)
 - [Sapiv1marginisolatedMarginDataData](docs/Sapiv1marginisolatedMarginDataData.md)
 - [Sapiv1marginleverageBracketBrackets](docs/Sapiv1marginleverageBracketBrackets.md)
 - [Sapiv1stakingproductListDetail](docs/Sapiv1stakingproductListDetail.md)
 - [Sapiv1stakingproductListQuota](docs/Sapiv1stakingproductListQuota.md)
 - [SnapshotFutures](docs/SnapshotFutures.md)
 - [SnapshotFuturesData](docs/SnapshotFuturesData.md)
 - [SnapshotFuturesDataAssets](docs/SnapshotFuturesDataAssets.md)
 - [SnapshotFuturesDataPosition](docs/SnapshotFuturesDataPosition.md)
 - [SnapshotFuturesSnapshotVos](docs/SnapshotFuturesSnapshotVos.md)
 - [SnapshotMargin](docs/SnapshotMargin.md)
 - [SnapshotMarginData](docs/SnapshotMarginData.md)
 - [SnapshotMarginDataUserAssets](docs/SnapshotMarginDataUserAssets.md)
 - [SnapshotMarginSnapshotVos](docs/SnapshotMarginSnapshotVos.md)
 - [SnapshotSpot](docs/SnapshotSpot.md)
 - [SnapshotSpotData](docs/SnapshotSpotData.md)
 - [SnapshotSpotDataBalances](docs/SnapshotSpotDataBalances.md)
 - [SnapshotSpotSnapshotVos](docs/SnapshotSpotSnapshotVos.md)
 - [SubAccountCOINFuturesDetails](docs/SubAccountCOINFuturesDetails.md)
 - [SubAccountCOINFuturesDetailsAssets](docs/SubAccountCOINFuturesDetailsAssets.md)
 - [SubAccountCOINFuturesPositionRisk](docs/SubAccountCOINFuturesPositionRisk.md)
 - [SubAccountCOINFuturesPositionRiskDeliveryPositionRiskVos](docs/SubAccountCOINFuturesPositionRiskDeliveryPositionRiskVos.md)
 - [SubAccountCOINFuturesSummary](docs/SubAccountCOINFuturesSummary.md)
 - [SubAccountCOINFuturesSummaryDeliveryAccountSummaryResp](docs/SubAccountCOINFuturesSummaryDeliveryAccountSummaryResp.md)
 - [SubAccountCOINFuturesSummaryDeliveryAccountSummaryRespSubAccountList](docs/SubAccountCOINFuturesSummaryDeliveryAccountSummaryRespSubAccountList.md)
 - [SubAccountUSDTFuturesDetails](docs/SubAccountUSDTFuturesDetails.md)
 - [SubAccountUSDTFuturesDetailsFutureAccountResp](docs/SubAccountUSDTFuturesDetailsFutureAccountResp.md)
 - [SubAccountUSDTFuturesDetailsFutureAccountRespAssets](docs/SubAccountUSDTFuturesDetailsFutureAccountRespAssets.md)
 - [SubAccountUSDTFuturesPositionRisk](docs/SubAccountUSDTFuturesPositionRisk.md)
 - [SubAccountUSDTFuturesSummary](docs/SubAccountUSDTFuturesSummary.md)
 - [SubAccountUSDTFuturesSummaryFutureAccountSummaryResp](docs/SubAccountUSDTFuturesSummaryFutureAccountSummaryResp.md)
 - [SubAccountUSDTFuturesSummaryFutureAccountSummaryRespSubAccountList](docs/SubAccountUSDTFuturesSummaryFutureAccountSummaryRespSubAccountList.md)
 - [Ticker](docs/Ticker.md)
 - [TickerList](docs/TickerList.md)
 - [Trade](docs/Trade.md)
 - [Transaction](docs/Transaction.md)

## Documentation For Authorization


## ApiKeyAuth

- **Type**: API key
- **API key parameter name**: X-MBX-APIKEY
- **Location**: HTTP header


## Author


