# coding: utf-8

"""
    Binance Public Spot API

    OpenAPI Specifications for the Binance Public Spot API  API documents:   - [https://github.com/binance/binance-spot-api-docs](https://github.com/binance/binance-spot-api-docs)   - [https://binance-docs.github.io/apidocs/spot/en](https://binance-docs.github.io/apidocs/spot/en)  # noqa: E501

    OpenAPI spec version: 1.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from binance_spot.api_client import ApiClient


class C2CApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def sapi_v1_c2c_order_match_list_user_order_history_get(self, trade_type, timestamp, signature, **kwargs):  # noqa: E501
        """Get C2C Trade History (USER_DATA)  # noqa: E501

        - If startTimestamp and endTimestamp are not sent, the recent 30-day data will be returned. - The max interval between startTimestamp and endTimestamp is 30 days.  Weight(IP): 1  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.sapi_v1_c2c_order_match_list_user_order_history_get(trade_type, timestamp, signature, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_type: (required)
        :param int timestamp: UTC timestamp in ms (required)
        :param str signature: Signature (required)
        :param int start_timestamp: UTC timestamp in ms
        :param int end_timestamp: UTC timestamp in ms
        :param int page: Default 1
        :param int rows: default 100, max 100
        :param int recv_window: The value cannot be greater than 60000
        :return: InlineResponse200191
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.sapi_v1_c2c_order_match_list_user_order_history_get_with_http_info(trade_type, timestamp, signature, **kwargs)  # noqa: E501
        else:
            (data) = self.sapi_v1_c2c_order_match_list_user_order_history_get_with_http_info(trade_type, timestamp, signature, **kwargs)  # noqa: E501
            return data

    def sapi_v1_c2c_order_match_list_user_order_history_get_with_http_info(self, trade_type, timestamp, signature, **kwargs):  # noqa: E501
        """Get C2C Trade History (USER_DATA)  # noqa: E501

        - If startTimestamp and endTimestamp are not sent, the recent 30-day data will be returned. - The max interval between startTimestamp and endTimestamp is 30 days.  Weight(IP): 1  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.sapi_v1_c2c_order_match_list_user_order_history_get_with_http_info(trade_type, timestamp, signature, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str trade_type: (required)
        :param int timestamp: UTC timestamp in ms (required)
        :param str signature: Signature (required)
        :param int start_timestamp: UTC timestamp in ms
        :param int end_timestamp: UTC timestamp in ms
        :param int page: Default 1
        :param int rows: default 100, max 100
        :param int recv_window: The value cannot be greater than 60000
        :return: InlineResponse200191
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['trade_type', 'timestamp', 'signature', 'start_timestamp', 'end_timestamp', 'page', 'rows', 'recv_window']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method sapi_v1_c2c_order_match_list_user_order_history_get" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'trade_type' is set
        if ('trade_type' not in params or
                params['trade_type'] is None):
            raise ValueError("Missing the required parameter `trade_type` when calling `sapi_v1_c2c_order_match_list_user_order_history_get`")  # noqa: E501
        # verify the required parameter 'timestamp' is set
        if ('timestamp' not in params or
                params['timestamp'] is None):
            raise ValueError("Missing the required parameter `timestamp` when calling `sapi_v1_c2c_order_match_list_user_order_history_get`")  # noqa: E501
        # verify the required parameter 'signature' is set
        if ('signature' not in params or
                params['signature'] is None):
            raise ValueError("Missing the required parameter `signature` when calling `sapi_v1_c2c_order_match_list_user_order_history_get`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'trade_type' in params:
            query_params.append(('tradeType', params['trade_type']))  # noqa: E501
        if 'start_timestamp' in params:
            query_params.append(('startTimestamp', params['start_timestamp']))  # noqa: E501
        if 'end_timestamp' in params:
            query_params.append(('endTimestamp', params['end_timestamp']))  # noqa: E501
        if 'page' in params:
            query_params.append(('page', params['page']))  # noqa: E501
        if 'rows' in params:
            query_params.append(('rows', params['rows']))  # noqa: E501
        if 'recv_window' in params:
            query_params.append(('recvWindow', params['recv_window']))  # noqa: E501
        if 'timestamp' in params:
            query_params.append(('timestamp', params['timestamp']))  # noqa: E501
        if 'signature' in params:
            query_params.append(('signature', params['signature']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['ApiKeyAuth']  # noqa: E501

        return self.api_client.call_api(
            '/sapi/v1/c2c/orderMatch/listUserOrderHistory', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='InlineResponse200191',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
